/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor.h
 *
 * Project:
 * --------
 *   MT6219
 *
 * Description:
 * ------------
 *   CMOS sensor header file
 *
 * Author:
 * -------
 * -------
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#ifndef _IMAGE_SENSOR_SP0838_H
#define _IMAGE_SENSOR_SP0838_H

	#include "isp_if.h"
	#include "drv_features.h"
	#include "sensor_struct.h"
	
    //#define __IMAGE_SENSOR_03M__  // VGA
    // #define __IMAGE_SENSOR_1M__   // 1.3M
    // #define __IMAGE_SENSOR_2M__   // 2M
    // #define __IMAGE_SENSOR_3M__   // 3M
    // #define __IMAGE_SENSOR_5M__   // 5M
    // #define __IMAGE_SENSOR_8M__   // 8M	 

	//------------------------Engineer mode---------------------------------
	
	#define SP0838_FACTORY_START_ADDR 70
	
	typedef enum SP0838_group_enum {
	   SP0838_AWB_GAIN=0,
	   SP0838_PRE_GAIN,
	   SP0838_SENSOR_DBLC,
	   SP0838_GAMMA_ENABLE,
	   SP0838_CMMCLK_CURRENT,
	   SP0838_FRAME_RATE_LIMITATION,
	   SP0838_REGISTER_EDITOR,
	   SP0838_GROUP_TOTAL_NUMS
	} SP0838_FACTORY_CCT_GROUP_ENUM;
	
	typedef enum SP0838_register_index {
	   SP0838_AWB_GAIN_R_INDEX=SP0838_FACTORY_START_ADDR,
	   SP0838_AWB_GAIN_B_INDEX,
	   SP0838_SENSOR_DBLC_INDEX,
	   SP0838_GAMMA_ENABLE_INDEX,
	   SP0838_CMMCLK_CURRENT_INDEX,	   
	   SP0838_FACTORY_END_ADDR
	} SP0838_FACTORY_REGISTER_INDEX;
	
	typedef enum SP0838_cct_register_index {
	   SP0838_GLOBAL_GAIN_INDEX=0,
	   SP0838_PRE_GAIN_R_INDEX,
	   SP0838_PRE_GAIN_B_INDEX,
	   SP0838_CCT_END_ADDR
	} SP0838_CCT_REGISTER_INDEX;

	
	// API FOR ENGINEER FACTORY MODE
	void  SP0838_get_sensor_group_count(kal_int32* sensor_count_ptr);
	void  SP0838_get_sensor_group_info(kal_uint16 group_idx, kal_int8* group_name_ptr, kal_int32* item_count_ptr);
	void  SP0838_get_sensor_item_info(kal_uint16 group_idx,kal_uint16 item_idx, ENG_sensor_info* info_ptr);
	kal_bool SP0838_set_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, kal_int32 item_value);
	
	//------------------------Engineer mode---------------------------------
#if (!(defined(DRV_ISP_6238_SERIES) ||defined(DRV_ISP_6235_SERIES) ))	

	typedef struct {
		sensor_reg_struct	reg[SP0838_FACTORY_END_ADDR];
		sensor_reg_struct	cct[SP0838_CCT_END_ADDR];
	} sensor_data_struct;
#endif	
	// write camera_para to sensor register 
	void SP0838_camera_para_to_sensor(void);
	// update camera_para from sensor register 
	void SP0838_sensor_to_camera_para(void);
	// config sensor callback function 
	void SP0838_image_sensor_func_config(void);
	// detect sensor id
	kal_uint32 SP0838_detect_sensor_id(void);
	void SP0838_get_sensor_prefix_name(kal_char* buf);
	void  SP0838_dispatch_camera_info(void);
	kal_uint32 SP0838_get_valid_camera_type(void);	
	// Compact Image Sensor Module Power ON/OFF

#if (!defined(DRV_ISP_6238_SERIES))
	/* AE CONTROL CRITERION */
	extern kal_uint8  AE_AWB_CAL_PERIOD;
	extern kal_uint8  AE_GAIN_DELAY_PERIOD;
	extern kal_uint8  AE_SHUTTER_DELAY_PERIOD;
#endif

	/* CAMERA PREVIEW FRAME RATE DEFINITION */
	#define SP0838_CAM_PREVIEW_15FPS

	#define SP0838_SYSTEM_CLK                           (48*1000*1000)
	/* PIXEL CLOCK USED BY BANDING FILTER CACULATION*/
#if defined(SP0838_CAM_PREVIEW_15FPS)
	#define SP0838_PIXEL_CLK							         (SP0838_SYSTEM_CLK/8)		// 52/8 MHz
#elif defined(SP0838_CAM_PREVIEW_22FPS)
   #define SP0838_PIXEL_CLK							         (SP0838_SYSTEM_CLK/6)		// 52/6 MHz
#elif defined(SP0838_CAM_PREVIEW_30FPS)
   #define SP0838_PIXEL_CLK 						      	(SP0838_SYSTEM_CLK/4)		// 52/4 MHz
#endif

	/* SENSOR PIXEL/LINE NUMBERS IN ONE PERIOD */
	#define SP0838_VGA_PERIOD_PIXEL_NUMS					       804//784
	#define SP0838_VGA_PERIOD_LINE_NUMS						506//510
	

	/* SENSOR VGA SIZE */
	#define SP0838_IMAGE_SENSOR_VGA_WIDTH					(640)
	#define SP0838_IMAGE_SENSOR_VGA_HEIGHT					(480)

	/* SENSOR READ/WRITE ID */
	#define SP0838_WRITE_ID									0x30
	#define SP0838_READ_ID									       0x31
	
	
	#define SP0838_SENSOR_I2C_DELAY							0x40 //0x20

	#define SP0838_I2C_START_TRANSMISSION \
	{ \
		volatile kal_uint32 j; \
		SET_SCCB_CLK_OUTPUT; \
		SET_SCCB_DATA_OUTPUT; \
		SET_SCCB_CLK_HIGH; \
		SET_SCCB_DATA_HIGH; \
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);\
		SET_SCCB_DATA_LOW; \
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);\
		SET_SCCB_CLK_LOW; \
	}
	
	#define SP0838_I2C_STOP_TRANSMISSION \
	{ \
		volatile kal_uint32 j; \
		SET_SCCB_CLK_OUTPUT; \
		SET_SCCB_DATA_OUTPUT; \
		SET_SCCB_CLK_LOW; \
		SET_SCCB_DATA_LOW; \
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);\
		SET_SCCB_CLK_HIGH; \
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);\
		SET_SCCB_DATA_HIGH; \
	}

  
    #define SP0838_RESET_PIN_LOW   (REG_ISP_CMOS_SENSOR_MODE_CONFIG &= ~REG_CMOS_SENSOR_RESET_BIT)
    #define SP0838_RESET_PIN_HIGH  (REG_ISP_CMOS_SENSOR_MODE_CONFIG |= REG_CMOS_SENSOR_RESET_BIT)

    #define SP0838_PWRDN_PIN_LOW    (REG_ISP_CMOS_SENSOR_MODE_CONFIG &= ~REG_CMOS_SENSOR_POWER_ON_BIT)
    #define SP0838_PWRDN_PIN_HIGH    (REG_ISP_CMOS_SENSOR_MODE_CONFIG |= REG_CMOS_SENSOR_POWER_ON_BIT)
#endif /* _IMAGE_SENSOR_SP0838_H */
