/*****************************************************************************
 20120926 wxc (SP0838DetectSensorId 󷵻ֵNULL_SENSOR_ID0xffffffff)
              ΪMM_ERROR_SENSOR_READ_ID_FAIL (0xffff),sensor⡣)
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2010
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE.
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor_SP0838.c  V12.1
 *
 * Project:
 * --------
 *  
 *
 * Description:
 * ------------
 *  Image sensor driver function
 *  V1.0.0
 *
 * Author:
 * -------
 * Mormo
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *  * $Log$
 * 2011/06/13 Firstly Released By Mormo;
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "drv_comm.h"
#include "isp_comm_if.h"
#include "camera_sccb.h"
#include "image_sensor.h"
#include "cal_comm_def.h"
#include "isp_if.h"

/* #define __SP0838_DEBUG_TRACE__ */
#define SP0838_SET_PAGE0 CamWriteCmosSensor(0xfd , 0x00)
#define SP0838_SET_PAGE1 CamWriteCmosSensor(0xfd , 0x01)
kal_bool SP0838_CAM_BANDING_50HZ = KAL_FALSE;

static struct
{
  kal_bool BypassAe;
  kal_bool BypassAwb;
  kal_uint8 Ctrl3A;
  kal_uint8 AecMode3;
  kal_uint16 VideoFps;
  kal_uint32 IntClk; /* internal clock = half of pclk */
  kal_uint16 FrameHeight;
  kal_uint16 LineLength;
  IMAGE_SENSOR_INDEX_ENUM SensorIdx;
  sensor_data_struct *NvramData;
} SP0838Sensor;

/*************************************************************************
* FUNCTION
*    SP0838HalfAdjust
*
* DESCRIPTION
*    This function dividend / divisor and use round-up.
*
* PARAMETERS
*    DividEnd
*    Divisor
*
* RETURNS
*    [DividEnd / Divisor]
*
* LOCAL AFFECTED
*
*************************************************************************/
__inline static kal_uint32 SP0838HalfAdjust(kal_uint32 DividEnd, kal_uint32 Divisor)
{
  return (DividEnd + (Divisor >> 1)) / Divisor; /* that is [DividEnd / Divisor + 0.5]*/
}

/*************************************************************************
* FUNCTION
*    SP0838SetMirror
*
* DESCRIPTION
*    This function set the Mirror to the CMOS sensor
*
* PARAMETERS
*    Mirror
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838SetMirror(kal_uint8 Mirror)
{SP0838_SET_PAGE0;
  switch (Mirror)
  {
  case IMAGE_SENSOR_MIRROR_H:
    CamWriteCmosSensor(0x31, 0x30);
    break;
  case IMAGE_SENSOR_MIRROR_V:
    CamWriteCmosSensor(0x31, 0x50);
    break;
  case IMAGE_SENSOR_MIRROR_HV:
    CamWriteCmosSensor(0x31, 0x70);
    break;
  default:
    CamWriteCmosSensor(0x31, 0x10);
  }
}

/*************************************************************************
* FUNCTION
*    SP0838SetClock
*
* DESCRIPTION
*    This function set sensor vt clock and op clock
*
* PARAMETERS
*    Clk: vt clock
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838SetClock(kal_uint32 Clk)
{
  kal_uint8 ClkDiv;
  
  if (SP0838Sensor.IntClk == Clk)
  {
    return;
  }
  SP0838Sensor.IntClk = Clk;
  switch (SP0838Sensor.IntClk)
  {
  case SP0838_MCLK / 2: ClkDiv = 0x02; break; /* pclk = mclk */
  case SP0838_MCLK / 4: ClkDiv = 0x04; break; /* pclk = mclk / 2 */
  case SP0838_MCLK / 8: ClkDiv = 0x06; break; /* pclk = mclk / 4 */
  default: ASSERT(0);
  }
  SP0838_SET_PAGE0;
  CamWriteCmosSensor(0x30, ClkDiv);
}

/*************************************************************************
* FUNCTION
*    SP0838WriteShutter
*
* DESCRIPTION
*    This function apply Shutter to sensor
*
* PARAMETERS
*    Shutter: integration time
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838WriteShutter(kal_uint32 Shutter)
{SP0838_SET_PAGE0;
  CamWriteCmosSensor(0x03, Shutter >> 8);
  CamWriteCmosSensor(0x04, Shutter);
}

/*************************************************************************
* FUNCTION
*    SP0838ReadShutter
*
* DESCRIPTION
*    This function get shutter from sensor
*
* PARAMETERS
*    None
*
* RETURNS
*    Shutter: integration time
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint16 SP0838ReadShutter(void)
{SP0838_SET_PAGE0;
  return (CamReadCmosSensor(0x03) << 8)|CamReadCmosSensor(0x04);
}

/*************************************************************************
* FUNCTION
*    SP0838AeEnable
*
* DESCRIPTION
*    disable/enable AE
*
* PARAMETERS
*    Enable
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838AeEnable(kal_bool Enable)
{
  const kal_bool AeEnable = (SP0838Sensor.AecMode3&0x05) ? KAL_TRUE : KAL_FALSE;
  
  if (SP0838Sensor.BypassAe)
  {
    Enable = KAL_FALSE;
  }
  if (AeEnable == Enable)
  {
    return;
  }
  if (Enable)
  {
    SP0838Sensor.AecMode3 |= 0x05;
  }
  else
  {
    SP0838Sensor.AecMode3 &= 0x10;
  }
  SP0838_SET_PAGE0;
  CamWriteCmosSensor(0x32, SP0838Sensor.AecMode3);
}

/*************************************************************************
* FUNCTION
*    SP0838AwbEnable
*
* DESCRIPTION
*    disable/enable awb
*
* PARAMETERS
*    Enable
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838AwbEnable(kal_bool Enable)
{
  const kal_bool AwbEnable = (SP0838Sensor.Ctrl3A&0x10) ? KAL_TRUE : KAL_FALSE;
  
  if (SP0838Sensor.BypassAwb)
  {
    Enable = KAL_FALSE;
  }
  if (AwbEnable == Enable)
  {
    return;
  }
  if (Enable)
  {
    SP0838Sensor.Ctrl3A |= 0x10;
  }
  else
  {
    SP0838Sensor.Ctrl3A &= 0x05;
  }
    SP0838_SET_PAGE0;
  CamWriteCmosSensor(0x32, SP0838Sensor.Ctrl3A);
}

/*************************************************************************
* FUNCTION
*    SP0838SetBaseShutter
*
* DESCRIPTION
*    This function set base shutter to the CMOS sensor
*
* PARAMETERS
*    Banding: 50Hz or 60Hz
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838SetBaseShutter(kal_uint8 Banding)
{
#if 0
  const kal_uint16 bandStep = SP0838HalfAdjust(SP0838Sensor.IntClk, SP0838Sensor.LineLength * Banding * 2);
  
  CamWriteCmosSensor(0xE2, bandStep >> 8);
  CamWriteCmosSensor(0xE3, bandStep);
#endif
}

/*************************************************************************
* FUNCTION
*    SP0838SetDummy
*
* DESCRIPTION
*    This function add DummyPixel and DummyLine.
*
* PARAMETERS
*    DummyPixel
*    DummyLine
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838SetDummy(kal_uint16 DummyPixel, kal_uint16 DummyLine)
{
#if 0
  const kal_uint16 LineLength = DummyPixel + SP0838_PERIOD_PIXEL_NUMS;
  const kal_uint16 FrameHeight = DummyLine + SP0838_PERIOD_LINE_NUMS;
  kal_bool update = KAL_FALSE;
  
  /* add default dummy */
  DummyPixel += SP0838_IMAGE_SENSOR_HBLANKING;
  DummyLine += SP0838_IMAGE_SENSOR_VBLANKING;
  
  /* config line length */
  if (LineLength != SP0838Sensor.LineLength)
  {
    if (LineLength > SP0838_MAX_LINELENGTH)
    {
      ASSERT(0);
    }
    update = KAL_TRUE;
    SP0838Sensor.LineLength = LineLength;
    CamWriteCmosSensor(0x01, DummyPixel);
  }
  /* config frame height */
  if (FrameHeight != SP0838Sensor.FrameHeight)
  {
    if (FrameHeight > SP0838_MAX_FRAMEHEIGHT)
    {
      ASSERT(0);
    }
    update = KAL_TRUE;
    SP0838Sensor.FrameHeight = FrameHeight;
    CamWriteCmosSensor(0x02, DummyLine);
  }
  if (update)
  {
    CamWriteCmosSensor(0x0F, ((DummyLine >> 4)&0xF0)|((DummyPixel >> 8)&0x0F));
  }
#endif
}

/*************************************************************************
* FUNCTION
*    SP0838SetVideoFps
*
* DESCRIPTION
*    This function calculate & fix frame rate in video mode
*
* PARAMETERS
*    Fps: video frame rate, base on SP0838_FPS(x)
*
* RETURNS
*    Fps: real frame rate set by sensor
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint16 SP0838SetVideoFps(kal_uint16 Fps)
{
#if 0
  kal_uint32 LineLength, FrameHeight;
  kal_uint16 MaxExposure;
  
  /* get max line length */
  LineLength = SP0838Sensor.IntClk * SP0838_FPS(1) / (Fps * SP0838_PERIOD_LINE_NUMS);
  if (LineLength > SP0838_MAX_LINELENGTH) /* overflow check */
  {
    LineLength = SP0838_MAX_LINELENGTH;
  }
  if (LineLength < SP0838_PERIOD_PIXEL_NUMS)
  {
    LineLength = SP0838_PERIOD_PIXEL_NUMS;
  }
  
  /* get frame height */
  FrameHeight = SP0838Sensor.IntClk * SP0838_FPS(1) / (Fps * LineLength);
  if (FrameHeight > SP0838_MAX_FRAMEHEIGHT) /* overflow check */
  {
    FrameHeight = SP0838_MAX_FRAMEHEIGHT;
  }
  if (FrameHeight < SP0838_PERIOD_LINE_NUMS)
  {
    FrameHeight = SP0838_PERIOD_LINE_NUMS;
  }
  
  /* set max frame rate */
  SP0838SetDummy(LineLength - SP0838_PERIOD_PIXEL_NUMS, FrameHeight - SP0838_PERIOD_LINE_NUMS);
  
  /* set min frame rate */
  MaxExposure = FrameHeight - SP0838_SHUTTER_MAX_MARGIN;
  CamWriteCmosSensor(0xEC, 0x00); /* use exp level 1 */
  CamWriteCmosSensor(0xE4, MaxExposure >> 8); /* exp level 1: define max exposure */
  CamWriteCmosSensor(0xE5, MaxExposure);
  
  return SP0838Sensor.IntClk * SP0838_FPS(1) / (LineLength * FrameHeight);
#endif
}

/*************************************************************************
* FUNCTION
*    SP0838SetMinFps
*
* DESCRIPTION
*    This function calculate & set min frame rate in camera preview mode
*
* PARAMETERS
*    Fps: min frame rate, base on SP0838_FPS(x)
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838SetMinFps(kal_uint16 Fps)
{
#if 0
  kal_uint32 FrameHeight;
  kal_uint16 MaxExposure;
  
  /* get max frame height */
  FrameHeight = SP0838HalfAdjust(SP0838Sensor.IntClk * SP0838_FPS(1), Fps * SP0838Sensor.LineLength);
  
  /* set min frame rate */
  MaxExposure = FrameHeight - SP0838_SHUTTER_MAX_MARGIN;
  CamWriteCmosSensor(0xEC, 0x30); /* use exp level 4, can not use level 1??? */
  CamWriteCmosSensor(0xEA, MaxExposure >> 8); /* exp level 4: define max exposure */
  CamWriteCmosSensor(0xEB, MaxExposure);
#endif
}

/*************************************************************************
* FUNCTION
*    SP0838Ev
*
* DESCRIPTION
*    Exposure setting.
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838Ev(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Exposure = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Exposure->IsSupport = KAL_TRUE;
    Exposure->ItemCount = 10;
    Exposure->SupportItem[0] = CAM_EV_NEG_4_3;
    Exposure->SupportItem[1] = CAM_EV_NEG_3_3;
    Exposure->SupportItem[2] = CAM_EV_NEG_2_3;
    Exposure->SupportItem[3] = CAM_EV_NEG_1_3;
    Exposure->SupportItem[4] = CAM_EV_ZERO;
    Exposure->SupportItem[5] = CAM_EV_POS_1_3;
    Exposure->SupportItem[6] = CAM_EV_POS_2_3;
    Exposure->SupportItem[7] = CAM_EV_POS_3_3;
    Exposure->SupportItem[8] = CAM_EV_POS_4_3;
    Exposure->SupportItem[9] = CAM_EV_NIGHT_SHOT;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    static const kal_uint8 Data[9][2]=
    {
      {0x90,0xc0}, /* EV -4 */
      {0x8c,0xd0}, /* EV -3 */
      {0x88,0xe0}, /* EV -2 */
      {0x84,0xf0}, /* EV -1 */
      {0x80,0x00}, /* EV 0 */
      {0x7c,0x10}, /* EV +1 */
      {0x78,0x20}, /* EV +2 */
      {0x74,0x30}, /* EV +3 */
      {0x70,0x40}, /* EV +4 */
    };
    kal_uint8 i;
    
    switch (In->FeatureSetValue)
    {
    case CAM_EV_NEG_4_3: i = 0; break;
    case CAM_EV_NEG_3_3: i = 1; break;
    case CAM_EV_NEG_2_3: i = 2; break;
    case CAM_EV_NEG_1_3: i = 3; break;
    case CAM_EV_ZERO:    i = 4; break;
    case CAM_EV_POS_1_3: i = 5; break;
    case CAM_EV_POS_2_3: i = 6; break;
    case CAM_EV_POS_3_3: i = 7; break;
    case CAM_EV_POS_4_3: i = 8; break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
    SP0838_SET_PAGE0;
    CamWriteCmosSensor(0xdf, Data[i][0]); /* SGNSET */
    CamWriteCmosSensor(0xdc, Data[i][1]); /* YBright */
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838Wb
*
* DESCRIPTION
*    Wb setting.
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838Wb(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Wb = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Wb->IsSupport = KAL_TRUE;
    Wb->ItemCount = 6;
    Wb->SupportItem[0] = CAM_WB_AUTO;
    Wb->SupportItem[1] = CAM_WB_CLOUD;
    Wb->SupportItem[2] = CAM_WB_DAYLIGHT;
    Wb->SupportItem[3] = CAM_WB_INCANDESCENCE;
    Wb->SupportItem[4] = CAM_WB_FLUORESCENT;
    Wb->SupportItem[5] = CAM_WB_TUNGSTEN;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    static const kal_uint8 AwbGain[5][2]=
    { /* R gain, B gain. base: 2.6bits, 0x40=1x,0x60=1.5x */
     {0x71,0x41}, /* cloud */
     {0x6b,0x48}, /* daylight */
     {0x41,0x71}, /* INCANDESCENCE */
     {0x5a,0x62}, /* FLUORESCENT */
     {0x57,0x66}, /* TUNGSTEN */
    };
    static kal_uint8 BakRGain, BakBGain;
    kal_uint8 RGain, BGain;
    kal_int8 i = sizeof(AwbGain) / sizeof(AwbGain[0]);
    SP0838_SET_PAGE1;
    RGain = CamReadCmosSensor(0x28);
    BGain = CamReadCmosSensor(0x29);
    while (--i >= 0)
    {
      if (RGain == AwbGain[i][0] && BGain == AwbGain[i][1])
      {
        break;
      }
    }
    if (i < 0)
    {
      BakRGain = RGain;
      BakBGain = BGain;
    }
    switch (In->FeatureSetValue)
    {
    case CAM_WB_AUTO:
      SP0838_SET_PAGE1;	
      CamWriteCmosSensor(0x28, BakRGain); /* for AWB can adjust back */
      CamWriteCmosSensor(0x29, BakBGain);
      SP0838AwbEnable(KAL_TRUE);
      return MM_ERROR_NONE;
    case CAM_WB_CLOUD:         i = 0; break;
    case CAM_WB_DAYLIGHT:      i = 1; break;
    case CAM_WB_INCANDESCENCE: i = 2; break;
    case CAM_WB_FLUORESCENT:   i = 3; break;
    case CAM_WB_TUNGSTEN:      i = 4; break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
    SP0838AwbEnable(KAL_FALSE);
    SP0838_SET_PAGE1;	
    CamWriteCmosSensor(0x28, AwbGain[i][0]); /* awb R gain */
    CamWriteCmosSensor(0x29, AwbGain[i][1]); /* awb B gain */
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838Effect
*
* DESCRIPTION
*    Effect setting.
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838Effect(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT Effect = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Effect->IsSupport = KAL_TRUE;
    Effect->ItemCount = 7;
    Effect->SupportItem[0] = CAM_EFFECT_ENC_NORMAL;
    Effect->SupportItem[1] = CAM_EFFECT_ENC_GRAYSCALE;
    Effect->SupportItem[2] = CAM_EFFECT_ENC_SEPIA;
    Effect->SupportItem[3] = CAM_EFFECT_ENC_SEPIAGREEN;
    Effect->SupportItem[4] = CAM_EFFECT_ENC_SEPIABLUE;
    Effect->SupportItem[5] = CAM_EFFECT_ENC_COLORINV;
    Effect->SupportItem[6] = CAM_EFFECT_ENC_GRAYINV;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
    static const kal_uint8 Data[7][3]=
    {
      {0x00,0x80,0x80}, /* NORMAL */
      {0x40,0x80,0x80}, /* GRAYSCALE */
      {0x20,0xc0,0x20}, /* SEPIA */
      {0x20,0x20,0x20}, /* SEPIAGREEN */
      {0x20,0x20,0xf0}, /* SEPIABLUE */
      {0x10,0x80,0x80}, /* COLORINV */
      {0x10,0x80,0x80}, /* GRAYINV */
    };
    kal_uint8 i;
    
    switch (In->FeatureSetValue)
    {
    case CAM_EFFECT_ENC_NORMAL:     i = 0; break;
    case CAM_EFFECT_ENC_GRAYSCALE:  i = 1; break;
    case CAM_EFFECT_ENC_SEPIA:      i = 2; break;
    case CAM_EFFECT_ENC_SEPIAGREEN: i = 3; break;
    case CAM_EFFECT_ENC_SEPIABLUE:  i = 4; break;
    case CAM_EFFECT_ENC_COLORINV:   i = 5; break;
    case CAM_EFFECT_ENC_GRAYINV:    i = 6; break;
    default:
      return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    }
    SP0838_SET_PAGE0;
    CamWriteCmosSensor(0x62, Data[i][0]); /* special effect */
    CamWriteCmosSensor(0x63, Data[i][1]); /* fixed Cb */
    CamWriteCmosSensor(0x64, Data[i][2]); /* fixed Cr */
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838StillCaptureSize
*
* DESCRIPTION
*    This function get capture size
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0838StillCaptureSize(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  const P_CAL_FEATURE_TYPE_ENUM_STRUCT CapSize = &Out->FeatureInfo.FeatureEnum;
  
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
    CapSize->IsSupport = KAL_TRUE;
    CapSize->ItemCount = 2;
    CapSize->SupportItem[0] = CAM_IMAGE_SIZE_WALLPAPER;
    CapSize->SupportItem[1] = CAM_IMAGE_SIZE_VGA;
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838Banding
*
* DESCRIPTION
*    This function get banding setting
*
* PARAMETERS
*    In, Out
*
* RETURNS
*    error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838Banding(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  const P_CAL_FEATURE_TYPE_ENUM_STRUCT Banding = &Out->FeatureInfo.FeatureEnum;
  
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_VIDEO_SUPPORT;
    Banding->IsSupport = KAL_TRUE;
    Banding->ItemCount = 2;
    Banding->SupportItem[0] = CAM_BANDING_50HZ;
    Banding->SupportItem[1] = CAM_BANDING_60HZ;
  }
  else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
  {
	switch (In->FeatureSetValue)
	{
		case CAM_BANDING_50HZ:
		SP0838_CAM_BANDING_50HZ = KAL_TRUE;
		break;
		
	case CAM_BANDING_60HZ:
		SP0838_CAM_BANDING_50HZ = KAL_FALSE;
		break;

	default:
       	return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
			
	}
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838SceneMode
*
* DESCRIPTION
*    This function get/set scene mode of sensor.
*
* PARAMETERS
*    IsCam: camera scene mode or not
*    In, Out
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838SceneMode(kal_bool IsCam, P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
  if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
  {
    const P_CAL_FEATURE_TYPE_ENUM_STRUCT SceneMode = &Out->FeatureInfo.FeatureEnum;
    
    Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
    Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
    Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
    SceneMode->IsSupport = KAL_TRUE;
    SceneMode->ItemCount = 2;
    if (IsCam)
    {
      SceneMode->SupportItem[0] = CAM_AUTO_DSC;
      SceneMode->SupportItem[1] = CAM_NIGHTSCENE;
    }
    else
    {
      SceneMode->SupportItem[0] = CAM_VIDEO_AUTO;
      SceneMode->SupportItem[1] = CAM_VIDEO_NIGHT;
    }
  }
 else if (CAL_FEATURE_SET_OPERATION == In->FeatureCtrlCode)
 {
 #if 0
    if (IsCam)
    {
      switch (In->FeatureSetValue)
      {
	 case CAM_AUTO_DSC:
        {
		if(SP0838_CAM_BANDING_50HZ == KAL_TRUE)
		{
				//caprure preview daylight 24M 50hz 20-8FPS maxgain:0x70                 
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5f);
				CamWriteCmosSensor(0xf5,0x78);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xb2);
				CamWriteCmosSensor(0x0f,0x60);
				CamWriteCmosSensor(0x16,0x60);
				CamWriteCmosSensor(0x17,0xa2);
				CamWriteCmosSensor(0x18,0xaa);
				CamWriteCmosSensor(0x1b,0x60);
				CamWriteCmosSensor(0x1c,0xaa);
				CamWriteCmosSensor(0xb4,0x20);
				CamWriteCmosSensor(0xb5,0x3a);
				CamWriteCmosSensor(0xb6,0x5e);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x70);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x70);
				CamWriteCmosSensor(0xcb,0xc );
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x0f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" priview 50Hz normal\r\n");

		}
		else
		{
				//caprure preview daylight 24M 60hz 20-8FPS maxgain:0x70                   
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x51);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5c);
				CamWriteCmosSensor(0xf5,0x75);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xb4);
				CamWriteCmosSensor(0x0f,0x5d);
				CamWriteCmosSensor(0x16,0x5d);
				CamWriteCmosSensor(0x17,0xa4);
				CamWriteCmosSensor(0x18,0xac);
				CamWriteCmosSensor(0x1b,0x5d);
				CamWriteCmosSensor(0x1c,0xac);
				CamWriteCmosSensor(0xb4,0x21);
				CamWriteCmosSensor(0xb5,0x3d);
				CamWriteCmosSensor(0xb6,0x4d);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x41);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x70);
				CamWriteCmosSensor(0xcb,0xf );
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x0f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" priview 60Hz normal\r\n");

		}
	}
	break;
	
       case CAM_NIGHTSCENE:
	{
		if(SP0838_CAM_BANDING_50HZ == KAL_TRUE)
		{
				//caprure preview night 24M 50hz 20-6FPS maxgain:0x78                  
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5f);
				CamWriteCmosSensor(0xf5,0x78);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xc0);
				CamWriteCmosSensor(0x0f,0x60);
				CamWriteCmosSensor(0x16,0x60);
				CamWriteCmosSensor(0x17,0xa8);
				CamWriteCmosSensor(0x18,0xb0);
				CamWriteCmosSensor(0x1b,0x60);
				CamWriteCmosSensor(0x1c,0xb0);
				CamWriteCmosSensor(0xb4,0x20);
				CamWriteCmosSensor(0xb5,0x3a);
				CamWriteCmosSensor(0xb6,0x5e);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x41);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x78);
				CamWriteCmosSensor(0xcb,0x10);
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x1f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" priview 50Hz night\r\n");	

		}
		else
		{
				//caprure preview night 24M 60hz 20-6FPS maxgain:0x78                  
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x51);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5c);
				CamWriteCmosSensor(0xf5,0x75);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xc1);
				CamWriteCmosSensor(0x0f,0x5d);
				CamWriteCmosSensor(0x16,0x5d);
				CamWriteCmosSensor(0x17,0xa9);
				CamWriteCmosSensor(0x18,0xb1);
				CamWriteCmosSensor(0x1b,0x5d);
				CamWriteCmosSensor(0x1c,0xb1);
				CamWriteCmosSensor(0xb4,0x21);
				CamWriteCmosSensor(0xb5,0x3d);
				CamWriteCmosSensor(0xb6,0x4d);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x41);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x78);
				CamWriteCmosSensor(0xcb,0x14);
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x1f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" priview 60Hz night\r\n");				

		}
	}		
	break;
	
		default:
       		return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
       }
    }
     else
    {
      switch (In->FeatureSetValue)
      {
    	case CAM_VIDEO_AUTO:
	{
		if(SP0838_CAM_BANDING_50HZ == KAL_TRUE)
		{
				//Video record daylight 24M 50hz fix 20FPS maxgain:0x78 
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5f);
				CamWriteCmosSensor(0xf5,0x78);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xa9);
				CamWriteCmosSensor(0x0f,0x60);
				CamWriteCmosSensor(0x16,0x60);
				CamWriteCmosSensor(0x17,0x91);
				CamWriteCmosSensor(0x18,0x99);
				CamWriteCmosSensor(0x1b,0x60);
				CamWriteCmosSensor(0x1c,0x99);
				CamWriteCmosSensor(0xb4,0x20);
				CamWriteCmosSensor(0xb5,0x3a);
				CamWriteCmosSensor(0xb6,0x5e);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x78);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x41);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x78);
				CamWriteCmosSensor(0xcb,0x5 );
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x0f);		
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" video 50Hz normal\r\n");

		}
		else
		{
				//Video record daylight 24M 60hz fix 20FPS maxgain:0x78               
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x51);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5c);
				CamWriteCmosSensor(0xf5,0x75);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xa9);
				CamWriteCmosSensor(0x0f,0x5d);
				CamWriteCmosSensor(0x16,0x5d);
				CamWriteCmosSensor(0x17,0x91);
				CamWriteCmosSensor(0x18,0x99);
				CamWriteCmosSensor(0x1b,0x5d);
				CamWriteCmosSensor(0x1c,0x99);
				CamWriteCmosSensor(0xb4,0x21);
				CamWriteCmosSensor(0xb5,0x3d);
				CamWriteCmosSensor(0xb6,0x4d);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x78);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x41);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x78);
				CamWriteCmosSensor(0xcb,0x6 );
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x0f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" video 60Hz normal\r\n");

		}
	}
	break;
	
	case CAM_VIDEO_NIGHT:
	{
		if(SP0838_CAM_BANDING_50HZ == KAL_TRUE)
		{
				//Video record night 24M 50hz 20-10FPS maxgain:0x78                 
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x62);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5f);
				CamWriteCmosSensor(0xf5,0x78);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xb6);
				CamWriteCmosSensor(0x0f,0x60);
				CamWriteCmosSensor(0x16,0x60);
				CamWriteCmosSensor(0x17,0x9e);
				CamWriteCmosSensor(0x18,0xa6);
				CamWriteCmosSensor(0x1b,0x60);
				CamWriteCmosSensor(0x1c,0xa6);
				CamWriteCmosSensor(0xb4,0x20);
				CamWriteCmosSensor(0xb5,0x3a);
				CamWriteCmosSensor(0xb6,0x5e);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x78);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x41);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x78);
				CamWriteCmosSensor(0xcb,0xa );
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x1f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" video 50Hz night\r\n");		

		}
		else
		{
				//Video record night 24M 60hz 20-10FPS maxgain:0x78               
				CamWriteCmosSensor(0xfd,0x00);
				CamWriteCmosSensor(0x05,0x0 );
				CamWriteCmosSensor(0x06,0x0 );
				CamWriteCmosSensor(0x09,0x1 );
				CamWriteCmosSensor(0x0a,0x76);
				CamWriteCmosSensor(0xf0,0x51);
				CamWriteCmosSensor(0xf1,0x0 );
				CamWriteCmosSensor(0xf2,0x5c);
				CamWriteCmosSensor(0xf5,0x75);
				CamWriteCmosSensor(0xfd,0x01);
				CamWriteCmosSensor(0x00,0xb7);
				CamWriteCmosSensor(0x0f,0x5d);
				CamWriteCmosSensor(0x16,0x5d);
				CamWriteCmosSensor(0x17,0x9f);
				CamWriteCmosSensor(0x18,0xa7);
				CamWriteCmosSensor(0x1b,0x5d);
				CamWriteCmosSensor(0x1c,0xa7);
				CamWriteCmosSensor(0xb4,0x21);
				CamWriteCmosSensor(0xb5,0x3d);
				CamWriteCmosSensor(0xb6,0x4d);
				CamWriteCmosSensor(0xb9,0x40);
				CamWriteCmosSensor(0xba,0x4f);
				CamWriteCmosSensor(0xbb,0x47);
				CamWriteCmosSensor(0xbc,0x45);
				CamWriteCmosSensor(0xbd,0x43);
				CamWriteCmosSensor(0xbe,0x42);
				CamWriteCmosSensor(0xbf,0x42);
				CamWriteCmosSensor(0xc0,0x42);
				CamWriteCmosSensor(0xc1,0x41);
				CamWriteCmosSensor(0xc2,0x41);
				CamWriteCmosSensor(0xc3,0x41);
				CamWriteCmosSensor(0xc4,0x41);
				CamWriteCmosSensor(0xc5,0x78);
				CamWriteCmosSensor(0xc6,0x41);
				CamWriteCmosSensor(0xca,0x78);
				CamWriteCmosSensor(0xcb,0xc );
				CamWriteCmosSensor(0x14,0x20);
				CamWriteCmosSensor(0x15,0x1f);
				CamWriteCmosSensor(0xfd,0x00);
				dbg_print(" video 60Hz night\r\n");		

		}

	}
	break;

	default:
       	return MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
       }
     }
#endif	 
   }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838NightMode
*
* DESCRIPTION
*    This function set night mode to sensor.
*
* PARAMETERS
*    Enable
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838NightMode(kal_uint16 videomode,kal_uint16 nightmode,kal_uint16 bandingmode)
{
	if(!videomode)//camera
	{
			if(!nightmode)//daylight
			{
				if(!bandingmode)//50hz
				{
					//caprure preview daylight 24M 50hz 20-8FPS maxgain:0x70				 
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5f);
					CamWriteCmosSensor(0xf5,0x78);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xb2);
					CamWriteCmosSensor(0x0f,0x60);
					CamWriteCmosSensor(0x16,0x60);
					CamWriteCmosSensor(0x17,0xa2);
					CamWriteCmosSensor(0x18,0xaa);
					CamWriteCmosSensor(0x1b,0x60);
					CamWriteCmosSensor(0x1c,0xaa);
					CamWriteCmosSensor(0xb4,0x20);
					CamWriteCmosSensor(0xb5,0x3a);
					CamWriteCmosSensor(0xb6,0x5e);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x70);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x70);
					CamWriteCmosSensor(0xcb,0xc );
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x0f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" priview 50Hz normal\r\n");
				}
				else//60hz
				{
					//caprure preview daylight 24M 60hz 20-8FPS maxgain:0x70				   
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x51);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5c);
					CamWriteCmosSensor(0xf5,0x75);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xb4);
					CamWriteCmosSensor(0x0f,0x5d);
					CamWriteCmosSensor(0x16,0x5d);
					CamWriteCmosSensor(0x17,0xa4);
					CamWriteCmosSensor(0x18,0xac);
					CamWriteCmosSensor(0x1b,0x5d);
					CamWriteCmosSensor(0x1c,0xac);
					CamWriteCmosSensor(0xb4,0x21);
					CamWriteCmosSensor(0xb5,0x3d);
					CamWriteCmosSensor(0xb6,0x4d);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x41);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x70);
					CamWriteCmosSensor(0xcb,0xf );
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x0f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" priview 60Hz normal\r\n");
				}
		
			}
			else//night
			{
				if(!bandingmode)//50hz
				{
					//caprure preview night 24M 50hz 20-6FPS maxgain:0x78				   
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5f);
					CamWriteCmosSensor(0xf5,0x78);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xc0);
					CamWriteCmosSensor(0x0f,0x60);
					CamWriteCmosSensor(0x16,0x60);
					CamWriteCmosSensor(0x17,0xa8);
					CamWriteCmosSensor(0x18,0xb0);
					CamWriteCmosSensor(0x1b,0x60);
					CamWriteCmosSensor(0x1c,0xb0);
					CamWriteCmosSensor(0xb4,0x20);
					CamWriteCmosSensor(0xb5,0x3a);
					CamWriteCmosSensor(0xb6,0x5e);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x41);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x78);
					CamWriteCmosSensor(0xcb,0x10);
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x1f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" priview 50Hz night\r\n");	
				}
				else//60hz
				{
					//caprure preview night 24M 60hz 20-6FPS maxgain:0x78				   
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x51);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5c);
					CamWriteCmosSensor(0xf5,0x75);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xc1);
					CamWriteCmosSensor(0x0f,0x5d);
					CamWriteCmosSensor(0x16,0x5d);
					CamWriteCmosSensor(0x17,0xa9);
					CamWriteCmosSensor(0x18,0xb1);
					CamWriteCmosSensor(0x1b,0x5d);
					CamWriteCmosSensor(0x1c,0xb1);
					CamWriteCmosSensor(0xb4,0x21);
					CamWriteCmosSensor(0xb5,0x3d);
					CamWriteCmosSensor(0xb6,0x4d);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x41);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x78);
					CamWriteCmosSensor(0xcb,0x14);
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x1f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" priview 60Hz night\r\n");				
				}
			}

	}
	else//video
	{
			if(!nightmode)//daylight
			{
				if(!bandingmode)//50hz
				{
					//Video record daylight 24M 50hz fix 20FPS maxgain:0x78 
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5f);
					CamWriteCmosSensor(0xf5,0x78);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xa9);
					CamWriteCmosSensor(0x0f,0x60);
					CamWriteCmosSensor(0x16,0x60);
					CamWriteCmosSensor(0x17,0x91);
					CamWriteCmosSensor(0x18,0x99);
					CamWriteCmosSensor(0x1b,0x60);
					CamWriteCmosSensor(0x1c,0x99);
					CamWriteCmosSensor(0xb4,0x20);
					CamWriteCmosSensor(0xb5,0x3a);
					CamWriteCmosSensor(0xb6,0x5e);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x78);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x41);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x78);
					CamWriteCmosSensor(0xcb,0x5 );
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x0f);		
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" video 50Hz normal\r\n");
				}
				else//60hz
				{
					//Video record daylight 24M 60hz fix 20FPS maxgain:0x78 			  
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x51);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5c);
					CamWriteCmosSensor(0xf5,0x75);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xa9);
					CamWriteCmosSensor(0x0f,0x5d);
					CamWriteCmosSensor(0x16,0x5d);
					CamWriteCmosSensor(0x17,0x91);
					CamWriteCmosSensor(0x18,0x99);
					CamWriteCmosSensor(0x1b,0x5d);
					CamWriteCmosSensor(0x1c,0x99);
					CamWriteCmosSensor(0xb4,0x21);
					CamWriteCmosSensor(0xb5,0x3d);
					CamWriteCmosSensor(0xb6,0x4d);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x78);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x41);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x78);
					CamWriteCmosSensor(0xcb,0x6 );
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x0f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" video 60Hz normal\r\n");
				}
		
			}
			else//night
			{
				if(!bandingmode)//50hz
				{
					//Video record night 24M 50hz 20-10FPS maxgain:0x78 				
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x62);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5f);
					CamWriteCmosSensor(0xf5,0x78);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xb6);
					CamWriteCmosSensor(0x0f,0x60);
					CamWriteCmosSensor(0x16,0x60);
					CamWriteCmosSensor(0x17,0x9e);
					CamWriteCmosSensor(0x18,0xa6);
					CamWriteCmosSensor(0x1b,0x60);
					CamWriteCmosSensor(0x1c,0xa6);
					CamWriteCmosSensor(0xb4,0x20);
					CamWriteCmosSensor(0xb5,0x3a);
					CamWriteCmosSensor(0xb6,0x5e);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x78);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x41);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x78);
					CamWriteCmosSensor(0xcb,0xa );
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x1f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" video 50Hz night\r\n");
				}
				else//60hz
				{
					//Video record night 24M 60hz 20-10FPS maxgain:0x78 			  
					CamWriteCmosSensor(0xfd,0x00);
					CamWriteCmosSensor(0x05,0x0 );
					CamWriteCmosSensor(0x06,0x0 );
					CamWriteCmosSensor(0x09,0x1 );
					CamWriteCmosSensor(0x0a,0x76);
					CamWriteCmosSensor(0xf0,0x51);
					CamWriteCmosSensor(0xf1,0x0 );
					CamWriteCmosSensor(0xf2,0x5c);
					CamWriteCmosSensor(0xf5,0x75);
					CamWriteCmosSensor(0xfd,0x01);
					CamWriteCmosSensor(0x00,0xb7);
					CamWriteCmosSensor(0x0f,0x5d);
					CamWriteCmosSensor(0x16,0x5d);
					CamWriteCmosSensor(0x17,0x9f);
					CamWriteCmosSensor(0x18,0xa7);
					CamWriteCmosSensor(0x1b,0x5d);
					CamWriteCmosSensor(0x1c,0xa7);
					CamWriteCmosSensor(0xb4,0x21);
					CamWriteCmosSensor(0xb5,0x3d);
					CamWriteCmosSensor(0xb6,0x4d);
					CamWriteCmosSensor(0xb9,0x40);
					CamWriteCmosSensor(0xba,0x4f);
					CamWriteCmosSensor(0xbb,0x47);
					CamWriteCmosSensor(0xbc,0x45);
					CamWriteCmosSensor(0xbd,0x43);
					CamWriteCmosSensor(0xbe,0x42);
					CamWriteCmosSensor(0xbf,0x42);
					CamWriteCmosSensor(0xc0,0x42);
					CamWriteCmosSensor(0xc1,0x41);
					CamWriteCmosSensor(0xc2,0x41);
					CamWriteCmosSensor(0xc3,0x41);
					CamWriteCmosSensor(0xc4,0x41);
					CamWriteCmosSensor(0xc5,0x78);
					CamWriteCmosSensor(0xc6,0x41);
					CamWriteCmosSensor(0xca,0x78);
					CamWriteCmosSensor(0xcb,0xc );
					CamWriteCmosSensor(0x14,0x20);
					CamWriteCmosSensor(0x15,0x1f);
					CamWriteCmosSensor(0xfd,0x00);
					dbg_print(" video 60Hz night\r\n"); 	
				}
			}

	}
}

/*************************************************************************
* FUNCTION
*  SP0838GammaSelect
*
* DESCRIPTION
*  This function config the gamma curve fitting for  
*  different LCD performances.
*
* PARAMETERS
*  level: different gamma curves.
*         Typical level value is from 1 to 5 which 
*         means small level gamma to high level gamma.
*
* RETURNS
*  NONE
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838GammaSelect(kal_uint8 level)
{
  static const GammaData[][19] =
  {
    {0x00,0x1A,0x29,0x41,0x62,0x7C,0x90,0xA2,0xAF,0xBc,0xC5,0xCd,0xD5,0xDD,0xE5,0xEd,0xF5,0xFd,0xFF},
    {0x00,0x1A,0x29,0x41,0x62,0x7C,0x90,0xA2,0xAF,0xBc,0xC5,0xCd,0xD5,0xDD,0xE5,0xEd,0xF5,0xFd,0xFF},
    {0x00,0x1A,0x29,0x41,0x62,0x7C,0x90,0xA2,0xAF,0xBc,0xC5,0xCd,0xD5,0xDD,0xE5,0xEd,0xF5,0xFd,0xFF},
    {0x00,0x1A,0x29,0x41,0x62,0x7C,0x90,0xA2,0xAF,0xBc,0xC5,0xCd,0xD5,0xDD,0xE5,0xEd,0xF5,0xFd,0xFF},
    {0x00,0x1A,0x29,0x41,0x62,0x7C,0x90,0xA2,0xAF,0xBc,0xC5,0xCd,0xD5,0xDD,0xE5,0xEd,0xF5,0xFd,0xFF},
  };
  
  if (level >= sizeof(GammaData) / sizeof(GammaData[0]))
  {
    ASSERT(0);
  }
  SP0838_SET_PAGE0;
  CamWriteCmosSensor(0x8b, GammaData[level][0]); 
  CamWriteCmosSensor(0x8c, GammaData[level][1]); 
  CamWriteCmosSensor(0x8d, GammaData[level][2]); 
  CamWriteCmosSensor(0x8e, GammaData[level][3]); 
  CamWriteCmosSensor(0x8f, GammaData[level][4]); 
  CamWriteCmosSensor(0x90, GammaData[level][5]); 
  CamWriteCmosSensor(0x91, GammaData[level][6]); 
  CamWriteCmosSensor(0x92, GammaData[level][7]); 
  CamWriteCmosSensor(0x93, GammaData[level][8]); 
  CamWriteCmosSensor(0x94, GammaData[level][9]); 
  CamWriteCmosSensor(0x95, GammaData[level][10]); 
  CamWriteCmosSensor(0x96, GammaData[level][11]); 
  CamWriteCmosSensor(0x97, GammaData[level][12]); 
  CamWriteCmosSensor(0x98, GammaData[level][13]); 
  CamWriteCmosSensor(0x99, GammaData[level][14]); 
  CamWriteCmosSensor(0x9a, GammaData[level][15]); 
  CamWriteCmosSensor(0x9b, GammaData[level][16]);
  SP0838_SET_PAGE1;
  CamWriteCmosSensor(0x8d, GammaData[level][17]);
  CamWriteCmosSensor(0x8e, GammaData[level][18]);
  SP0838_SET_PAGE0;
}

/*************************************************************************
* FUNCTION
*    SP0838InitialSetting
*
* DESCRIPTION
*    This function initialize the registers of CMOS sensor
*
* PARAMETERS
*    None
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838InitialSetting(void)
{
CamWriteCmosSensor(0xfd , 0x00); //P0
CamWriteCmosSensor(0x1B , 0x02);
CamWriteCmosSensor(0x27 , 0xe8);
CamWriteCmosSensor(0x28 , 0x0B);
CamWriteCmosSensor(0x32 , 0x00);
CamWriteCmosSensor(0x22 , 0xc0);
CamWriteCmosSensor(0x26 , 0x10); 
CamWriteCmosSensor(0x31 , 0x10);   //Upside/mirr/Pclk inv/sub
CamWriteCmosSensor(0x5f , 0x11);   //Bayer order
CamWriteCmosSensor(0xfd , 0x01);   //P1
CamWriteCmosSensor(0x25 , 0x1a);   //Awb start
CamWriteCmosSensor(0x26 , 0xfb); 
CamWriteCmosSensor(0x28 , 0x75); 
CamWriteCmosSensor(0x29 , 0x4e);

CamWriteCmosSensor(0xfd , 0x00);   
CamWriteCmosSensor(0xe7 , 0x03); 
CamWriteCmosSensor(0xe7 , 0x00); 
CamWriteCmosSensor(0xfd , 0x01);

CamWriteCmosSensor(0x31 , 0x60);//64
CamWriteCmosSensor(0x32 , 0x18);
CamWriteCmosSensor(0x4d , 0xdc);
CamWriteCmosSensor(0x4e , 0x53);
CamWriteCmosSensor(0x41 , 0x8c);
CamWriteCmosSensor(0x42 , 0x57);
CamWriteCmosSensor(0x55 , 0xff);
CamWriteCmosSensor(0x56 , 0x00);
CamWriteCmosSensor(0x59 , 0x82);
CamWriteCmosSensor(0x5a , 0x00);
CamWriteCmosSensor(0x5d , 0xff);
CamWriteCmosSensor(0x5e , 0x6f);
CamWriteCmosSensor(0x57 , 0xff);
CamWriteCmosSensor(0x58 , 0x00);
CamWriteCmosSensor(0x5b , 0xff);
CamWriteCmosSensor(0x5c , 0xa8);
CamWriteCmosSensor(0x5f , 0x75);
CamWriteCmosSensor(0x60 , 0x00);
CamWriteCmosSensor(0x2d , 0x00);
CamWriteCmosSensor(0x2e , 0x00);
CamWriteCmosSensor(0x2f , 0x00);
CamWriteCmosSensor(0x30 , 0x00);
CamWriteCmosSensor(0x33 , 0x00);
CamWriteCmosSensor(0x34 , 0x00);
CamWriteCmosSensor(0x37 , 0x00);
CamWriteCmosSensor(0x38 , 0x00);  //awb end
CamWriteCmosSensor(0xfd , 0x00);  //P0
CamWriteCmosSensor(0x33 , 0x6f);  //LSC BPC EN
CamWriteCmosSensor(0x51 , 0x3f);  //BPC debug start
CamWriteCmosSensor(0x52 , 0x09);  
CamWriteCmosSensor(0x53 , 0x00);  
CamWriteCmosSensor(0x54 , 0x00);
CamWriteCmosSensor(0x55 , 0x10);  //BPC debug end
CamWriteCmosSensor(0x4f , 0x08);  //blueedge
CamWriteCmosSensor(0x50 , 0x08);
CamWriteCmosSensor(0x57 , 0x10);  //Raw filter debut start
CamWriteCmosSensor(0x58 , 0x10);
CamWriteCmosSensor(0x59 , 0x10);
CamWriteCmosSensor(0x56 , 0x70);
CamWriteCmosSensor(0x5a , 0x02);
CamWriteCmosSensor(0x5b , 0x02);
CamWriteCmosSensor(0x5c , 0x20);  //Raw filter debut end 
CamWriteCmosSensor(0x65 , 0x03);  //Sharpness debug start
CamWriteCmosSensor(0x66 , 0x01);
CamWriteCmosSensor(0x67 , 0x03);
CamWriteCmosSensor(0x68 , 0x46);
CamWriteCmosSensor(0x69 , 0x7f);
CamWriteCmosSensor(0x6a , 0x01);
CamWriteCmosSensor(0x6b , 0x04);
CamWriteCmosSensor(0x6c , 0x01);
CamWriteCmosSensor(0x6d , 0x03);  //Edge gain normal
CamWriteCmosSensor(0x6e , 0x46);  //Edge gain normal
CamWriteCmosSensor(0x6f , 0x7f);
CamWriteCmosSensor(0x70 , 0x01);
CamWriteCmosSensor(0x71 , 0x05);  //ֵ           
CamWriteCmosSensor(0x72 , 0x01);  //ֵ         
CamWriteCmosSensor(0x73 , 0x03);  //Եֵ     
CamWriteCmosSensor(0x74 , 0x46);  //Եֵ     
CamWriteCmosSensor(0x75 , 0x7f);  //ʹλ             
CamWriteCmosSensor(0x76 , 0x01);  //Sharpness debug end
CamWriteCmosSensor(0xcb , 0x07);  //HEQ&Saturation debug start 
CamWriteCmosSensor(0xcc , 0x04);
CamWriteCmosSensor(0xce , 0xff);
CamWriteCmosSensor(0xcf , 0x10);
CamWriteCmosSensor(0xd0 , 0x20);
CamWriteCmosSensor(0xd1 , 0x00);
CamWriteCmosSensor(0xd2 , 0x1c);
CamWriteCmosSensor(0xd3 , 0x16);
CamWriteCmosSensor(0xd4 , 0x00);
CamWriteCmosSensor(0xd6 , 0x1c);
CamWriteCmosSensor(0xd7 , 0x16);
CamWriteCmosSensor(0xdd , 0x70);  //Contrast
CamWriteCmosSensor(0xde , 0x90);  //HEQ&Saturation debug end
CamWriteCmosSensor(0x7f , 0xd7);  //Color Correction start
CamWriteCmosSensor(0x80 , 0xbc);                          
CamWriteCmosSensor(0x81 , 0xed);                          
CamWriteCmosSensor(0x82 , 0xd7);                          
CamWriteCmosSensor(0x83 , 0xd4);                          
CamWriteCmosSensor(0x84 , 0xd6);                          
CamWriteCmosSensor(0x85 , 0xff);                          
CamWriteCmosSensor(0x86 , 0x89);                          
CamWriteCmosSensor(0x87 , 0xf8);                          
CamWriteCmosSensor(0x88 , 0x3c);                          
CamWriteCmosSensor(0x89 , 0x33);                          
CamWriteCmosSensor(0x8a , 0x0f);  //Color Correction end 
CamWriteCmosSensor(0x8b , 0x00);  //gamma start
CamWriteCmosSensor(0x8c , 0x1a);               
CamWriteCmosSensor(0x8d , 0x29);               
CamWriteCmosSensor(0x8e , 0x41);               
CamWriteCmosSensor(0x8f , 0x62);               
CamWriteCmosSensor(0x90 , 0x7c);               
CamWriteCmosSensor(0x91 , 0x90);               
CamWriteCmosSensor(0x92 , 0xa2);               
CamWriteCmosSensor(0x93 , 0xaf);               
CamWriteCmosSensor(0x94 , 0xbc);               
CamWriteCmosSensor(0x95 , 0xc5);               
CamWriteCmosSensor(0x96 , 0xcd);               
CamWriteCmosSensor(0x97 , 0xd5);               
CamWriteCmosSensor(0x98 , 0xdd);               
CamWriteCmosSensor(0x99 , 0xe5);               
CamWriteCmosSensor(0x9a , 0xed);               
CamWriteCmosSensor(0x9b , 0xf5);               
CamWriteCmosSensor(0xfd , 0x01);  //P1         
CamWriteCmosSensor(0x8d , 0xfd);               
CamWriteCmosSensor(0x8e , 0xff);  //gamma end  
CamWriteCmosSensor(0xfd , 0x00);  //P0
CamWriteCmosSensor(0xca , 0xcf);
CamWriteCmosSensor(0xd8 , 0x48);  //UV outdoor
CamWriteCmosSensor(0xd9 , 0x48);  //UV indoor 
CamWriteCmosSensor(0xda , 0x48);  //UV dummy
CamWriteCmosSensor(0xdb , 0x48);  //UV lowlight
CamWriteCmosSensor(0xb9 , 0x00);  //Ygamma start
CamWriteCmosSensor(0xba , 0x04);
CamWriteCmosSensor(0xbb , 0x08);
CamWriteCmosSensor(0xbc , 0x10);
CamWriteCmosSensor(0xbd , 0x20);
CamWriteCmosSensor(0xbe , 0x30);
CamWriteCmosSensor(0xbf , 0x40);
CamWriteCmosSensor(0xc0 , 0x50);
CamWriteCmosSensor(0xc1 , 0x60);
CamWriteCmosSensor(0xc2 , 0x70);
CamWriteCmosSensor(0xc3 , 0x80);
CamWriteCmosSensor(0xc4 , 0x90);
CamWriteCmosSensor(0xc5 , 0xA0);
CamWriteCmosSensor(0xc6 , 0xB0);
CamWriteCmosSensor(0xc7 , 0xC0);
CamWriteCmosSensor(0xc8 , 0xD0);
CamWriteCmosSensor(0xc9 , 0xE0);
CamWriteCmosSensor(0xfd , 0x01);  //P1
CamWriteCmosSensor(0x89 , 0xf0);
CamWriteCmosSensor(0x8a , 0xff);  //Ygamma end
CamWriteCmosSensor(0xfd , 0x00);  //P0
CamWriteCmosSensor(0xe8 , 0x30);  //AEdebug start
CamWriteCmosSensor(0xe9 , 0x30);
CamWriteCmosSensor(0xea , 0x40);  //Alc Window sel
CamWriteCmosSensor(0xf4 , 0x1b);  //outdoor mode sel
CamWriteCmosSensor(0xf5 , 0x80);
CamWriteCmosSensor(0xf7 , 0x78);  //AE target
CamWriteCmosSensor(0xf8 , 0x63);  
CamWriteCmosSensor(0xf9 , 0x68);  //AE target
CamWriteCmosSensor(0xfa , 0x53);
CamWriteCmosSensor(0xfd , 0x01);  //P1
CamWriteCmosSensor(0x09 , 0x31);  //AE Step 3.0
CamWriteCmosSensor(0x0a , 0x85);
CamWriteCmosSensor(0x0b , 0x0b);  //AE Step 3.0
CamWriteCmosSensor(0x14 , 0x20);
CamWriteCmosSensor(0x15 , 0x0f);
CamWriteCmosSensor(0xfd , 0x00);  //P0
CamWriteCmosSensor(0x05 , 0x00);  
CamWriteCmosSensor(0x06 , 0x00);
CamWriteCmosSensor(0x09 , 0x01);
CamWriteCmosSensor(0x0a , 0x76);
CamWriteCmosSensor(0xf0 , 0x62);
CamWriteCmosSensor(0xf1 , 0x00);
CamWriteCmosSensor(0xf2 , 0x5f);
CamWriteCmosSensor(0xf5 , 0x78);
CamWriteCmosSensor(0xfd , 0x01);  //P1
CamWriteCmosSensor(0x00 , 0xba);
CamWriteCmosSensor(0x0f , 0x60);
CamWriteCmosSensor(0x16 , 0x60);
CamWriteCmosSensor(0x17 , 0xa2);
CamWriteCmosSensor(0x18 , 0xaa);
CamWriteCmosSensor(0x1b , 0x60);
CamWriteCmosSensor(0x1c , 0xaa);
CamWriteCmosSensor(0xb4 , 0x20);
CamWriteCmosSensor(0xb5 , 0x3a);
CamWriteCmosSensor(0xb6 , 0x5e);
CamWriteCmosSensor(0xb9 , 0x40);
CamWriteCmosSensor(0xba , 0x4f);
CamWriteCmosSensor(0xbb , 0x47);
CamWriteCmosSensor(0xbc , 0x45);
CamWriteCmosSensor(0xbd , 0x43);
CamWriteCmosSensor(0xbe , 0x42);
CamWriteCmosSensor(0xbf , 0x42);
CamWriteCmosSensor(0xc0 , 0x42);
CamWriteCmosSensor(0xc1 , 0x41);
CamWriteCmosSensor(0xc2 , 0x41);
CamWriteCmosSensor(0xc3 , 0x41);
CamWriteCmosSensor(0xc4 , 0x41);
CamWriteCmosSensor(0xc5 , 0x78);
CamWriteCmosSensor(0xc6 , 0x41);
CamWriteCmosSensor(0xca , 0x78);
CamWriteCmosSensor(0xcb , 0x0c);  //AEdebug end

#if 1//caprure preview daylight 24M 50hz 20-8FPS maxgain:0x70	
CamWriteCmosSensor(0xfd , 0x00);
CamWriteCmosSensor(0x05 , 0x0 );
CamWriteCmosSensor(0x06 , 0x0 );
CamWriteCmosSensor(0x09 , 0x1 );
CamWriteCmosSensor(0x0a , 0x76);
CamWriteCmosSensor(0xf0 , 0x62);
CamWriteCmosSensor(0xf1 , 0x0 );
CamWriteCmosSensor(0xf2 , 0x5f);
CamWriteCmosSensor(0xf5 , 0x78);
CamWriteCmosSensor(0xfd , 0x01);
CamWriteCmosSensor(0x00 , 0xb2);
CamWriteCmosSensor(0x0f , 0x60);
CamWriteCmosSensor(0x16 , 0x60);
CamWriteCmosSensor(0x17 , 0xa2);
CamWriteCmosSensor(0x18 , 0xaa);
CamWriteCmosSensor(0x1b , 0x60);
CamWriteCmosSensor(0x1c , 0xaa);
CamWriteCmosSensor(0xb4 , 0x20);
CamWriteCmosSensor(0xb5 , 0x3a);
CamWriteCmosSensor(0xb6 , 0x5e);
CamWriteCmosSensor(0xb9 , 0x40);
CamWriteCmosSensor(0xba , 0x4f);
CamWriteCmosSensor(0xbb , 0x47);
CamWriteCmosSensor(0xbc , 0x45);
CamWriteCmosSensor(0xbd , 0x43);
CamWriteCmosSensor(0xbe , 0x42);
CamWriteCmosSensor(0xbf , 0x42);
CamWriteCmosSensor(0xc0 , 0x42);
CamWriteCmosSensor(0xc1 , 0x41);
CamWriteCmosSensor(0xc2 , 0x41);
CamWriteCmosSensor(0xc3 , 0x41);
CamWriteCmosSensor(0xc4 , 0x41);
CamWriteCmosSensor(0xc5 , 0x70);
CamWriteCmosSensor(0xc6 , 0x41);
CamWriteCmosSensor(0xca , 0x70);
CamWriteCmosSensor(0xcb , 0xc );
CamWriteCmosSensor(0xfd , 0x00);
#endif	

CamWriteCmosSensor(0xfd , 0x00);  //P0
CamWriteCmosSensor(0x32 , 0x15);  //Auto_mode set
CamWriteCmosSensor(0x34 , 0x66);  //Isp_mode set
CamWriteCmosSensor(0x35 , 0x00);  //out format
}

/*************************************************************************
* FUNCTION
*	SP0838_Write_More_Registers
*
* DESCRIPTION
*	This function is served for FAE to modify the necessary Init Regs. Do not modify the regs
*     in init_SP0838() directly.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838MoreSetting(void)
{
	//  TODO: FAE Modify the Init Regs here!!! 
    SP0838GammaSelect(1);
}
/*************************************************************************
* FUNCTION
*    SP0838GetSensorInfo
*
* DESCRIPTION
*    This function set sensor infomation
*
* PARAMETERS
*    Info
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838GetSensorInfo(P_IMAGE_SENSOR_GET_SENSOR_INFO_STRUCT Info)
{
  Info->SensorId = SP0838_SENSOR_ID;
  Info->SensorIf = IMAGE_SENSOR_IF_PARALLEL;
  Info->PreviewNormalDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PreviewHMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PreviewVMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PreviewHVMirrorDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->CaptureDataFormat = IMAGE_SENSOR_DATA_OUT_FORMAT_UYVY;
  Info->PixelClkInv = KAL_FALSE;
  Info->PixelClkPolarity = POLARITY_LOW;
  Info->HsyncPolarity = POLARITY_LOW;
  Info->VsyncPolarity = POLARITY_HIGH;
  Info->PreviewMclkFreq = SP0838_MCLK;
  Info->CaptureMclkFreq = SP0838_MCLK;
  Info->VideoMclkFreq = SP0838_MCLK;
  Info->PreviewWidth = SP0838_IMAGE_SENSOR_WIDTH_DRV;
  Info->PreviewHeight = SP0838_IMAGE_SENSOR_HEIGHT_DRV;
  Info->FullWidth = SP0838_IMAGE_SENSOR_WIDTH_DRV;
  Info->FullHeight = SP0838_IMAGE_SENSOR_HEIGHT_DRV;
  Info->SensorAfSupport = KAL_FALSE;
  Info->SensorFlashSupport = KAL_FALSE;
}

/*************************************************************************
* FUNCTION
*    SP0838PowerOn
*
* DESCRIPTION
*    This function reset sensor and read id
*
* PARAMETERS
*    None
*
* RETURNS
*    sensor id
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint16 SP0838PowerOn(void)
{
  kal_uint16 SensorId;
  
  CisModulePowerOn(SP0838Sensor.SensorIdx, KAL_TRUE);
  kal_sleep_task(2);  /* delay for power stable */
  CameraSccbOpen(CAMERA_SCCB_SENSOR, SP0838_WRITE_ID, CAMERA_SCCB_8BIT, CAMERA_SCCB_8BIT, 100);
  CamPdnPinCtrl(SP0838Sensor.SensorIdx, 0);
  
  CamRstPinCtrl(SP0838Sensor.SensorIdx, 1);
  kal_sleep_task(1);
  CamRstPinCtrl(SP0838Sensor.SensorIdx, 0);
  kal_sleep_task(1);
  CamRstPinCtrl(SP0838Sensor.SensorIdx, 1);
  kal_sleep_task(3);
  
  SensorId = CamReadCmosSensor(0x02);
  if (SensorId != SP0838_SENSOR_ID) /* READ SENSOR ID */
  {
    //dbg_print("SP0838PowerOn!the SensorId = %x , SP0838Sensor.SensorIdx = %d\r\n",SensorId,SP0838Sensor.SensorIdx);
#if defined(__SP0838_DEBUG_TRACE__)
    kal_print_string_trace(MOD_ENG, TRACE_ERROR, "SENSOR ID: %x", SensorId);
#endif
  }
  return SensorId;
}

/*************************************************************************
* FUNCTION
*    SP0838DetectSensorId
*
* DESCRIPTION
*    This function detect sensor id
*
* PARAMETERS
*    None
*
* RETURNS
*    sensor id
*
* LOCAL AFFECTED
*
*************************************************************************/
static kal_uint32 SP0838DetectSensorId(void)
{
  MM_ERROR_CODE_ENUM SP0838SensorClose(void);
  kal_uint8 SensorId;
  IMAGE_SENSOR_INDEX_ENUM InvIdx;
  kal_int8 i, j;
  
  switch (SP0838Sensor.SensorIdx)
  {
  case IMAGE_SENSOR_MAIN:
  case IMAGE_SENSOR_BAK1:
    InvIdx = IMAGE_SENSOR_SUB;
    break;
  default:
    InvIdx = IMAGE_SENSOR_MAIN;
    break;
  }
  for (i = 1; i >= 0; i--)
  {
    for (j = 1; j >= 0; j--)
    {
      CamRstPinCtrl(InvIdx, i);
      CamPdnPinCtrl(InvIdx, j);
      SensorId = SP0838PowerOn();
      SP0838SensorClose();
      //dbg_print("SP0838DetectSensorId!SP0838_SENSOR_ID = %x,i=%d,j=%d\r\n",SP0838_SENSOR_ID,i,j);
      if (SP0838_SENSOR_ID == SensorId)
      {
        return SP0838_SENSOR_ID;
      }
    }
  }
  return MM_ERROR_SENSOR_READ_ID_FAIL;//NULL_SENSOR_ID 20120926 wxc
}

/*************************************************************************
* FUNCTION
*    SP0838InitOperationPara
*
* DESCRIPTION
*    This function set sensor operation para
*
* PARAMETERS
*    Para
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838InitOperationPara(P_IMAGE_SENSOR_GET_INIT_OPERATION_PARA_STRUCT Para)
{
  Para->CaptureDelayFrame = 2;
  Para->PreviewDelayFrame = 4;
  Para->PreviewDisplayWaitFrame = 8;
}

/*************************************************************************
* FUNCTION
*    SP0838Preview
*
* DESCRIPTION
*    This function set to preview mode
*
* PARAMETERS
*    Id, In, Out
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838Preview(CAL_SCENARIO_ENUM Id, P_IMAGE_SENSOR_SCENARIO_PARA_IN_STRUCT In, P_IMAGE_SENSOR_SCENARIO_PARA_OUT_STRUCT Out)
{
  SP0838SetMirror(In->ImageMirror);
  switch (Id)
  {
  case CAL_SCENARIO_VIDEO:
	  SP0838NightMode(1,In->NightMode,In->BandingFreq);
    break;
  default:
	  SP0838NightMode(0,In->NightMode,In->BandingFreq);
  }
  SP0838AeEnable(KAL_TRUE);
  SP0838AwbEnable(KAL_TRUE);
  
  Out->WaitStableFrameNum = 0;
  Out->GrabStartX = SP0838_X_START;
  Out->GrabStartY = SP0838_Y_START;
  Out->ExposureWindowWidth = SP0838_IMAGE_SENSOR_WIDTH;
  Out->ExposureWindowHeight = SP0838_IMAGE_SENSOR_HEIGHT;
}

/*************************************************************************
* FUNCTION
*    SP0838Capture
*
* DESCRIPTION
*    This function set to capture mode
*
* PARAMETERS
*    Id, In, Out
*
* RETURNS
*    None
*
* LOCAL AFFECTED
*
*************************************************************************/
static void SP0838Capture(CAL_SCENARIO_ENUM Id, P_IMAGE_SENSOR_SCENARIO_PARA_IN_STRUCT In, P_IMAGE_SENSOR_SCENARIO_PARA_OUT_STRUCT Out)
{
  Out->WaitStableFrameNum = 0;
  Out->GrabStartX = SP0838_X_START;
  Out->GrabStartY = SP0838_Y_START;
  Out->ExposureWindowWidth = SP0838_IMAGE_SENSOR_WIDTH;
  Out->ExposureWindowHeight = SP0838_IMAGE_SENSOR_HEIGHT;
}

/*************************************************************************
* FUNCTION
*    SP0838SensorOpen
*
* DESCRIPTION
*    This function read sensor id and init sensor
*
* PARAMETERS
*    None
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838SensorOpen(void)
{
#if 0
  if (SP0838PowerOn() != SP0838_SENSOR_ID)
  {
    return MM_ERROR_SENSOR_READ_ID_FAIL;
  }
#else
    MM_ERROR_CODE_ENUM SP0838SensorClose(void);
    kal_uint8 SensorId;
    IMAGE_SENSOR_INDEX_ENUM InvIdx;
    kal_int8 i, j;

    switch (SP0838Sensor.SensorIdx)
    {
        case IMAGE_SENSOR_MAIN:
        case IMAGE_SENSOR_BAK1:
            InvIdx = IMAGE_SENSOR_SUB;
            break;
        default:
            InvIdx = IMAGE_SENSOR_MAIN;
            break;
    }
    CamRstPinCtrl(InvIdx, 1);
    CamPdnPinCtrl(InvIdx,1);
    SensorId = SP0838PowerOn();
    if (SP0838_SENSOR_ID != SensorId)
    {
        //dbg_print("SP0838SensorOpen!the line = %d\r\n",__LINE__);
        kal_prompt_trace(MOD_MED,"Telacom SP0838SensorOpen!the line = %d\r\n",__LINE__);
        SP0838SensorClose();
        return MM_ERROR_SENSOR_READ_ID_FAIL;
    }
#endif

  SP0838InitialSetting();
 // SP0838MoreSetting();
  /* default setting */
  SP0838Sensor.BypassAe = KAL_FALSE;
  SP0838Sensor.BypassAwb = KAL_FALSE;
  SP0838Sensor.Ctrl3A = CamReadCmosSensor(0x32);
  SP0838Sensor.AecMode3 = CamReadCmosSensor(0x32);
  SP0838Sensor.VideoFps = 0;
  SP0838Sensor.IntClk = 0;
  SP0838Sensor.FrameHeight = 0;
  SP0838Sensor.LineLength = 0;
  
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838SensorFeatureCtrl
*
* DESCRIPTION
*    This function set sensor feature mode
*
* PARAMETERS
*    Id: scenario id
*    In: input parameter
*    Out: output parameter
*    OutLen: output parameter length
*    RealOutLen: real output parameter length
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838FlashMode(P_CAL_FEATURE_CTRL_STRUCT In, P_CAL_FEATURE_CTRL_STRUCT Out)
{
    if (CAL_FEATURE_QUERY_OPERATION == In->FeatureCtrlCode)
    {
        const P_CAL_FEATURE_TYPE_ENUM_STRUCT FlashMode = &Out->FeatureInfo.FeatureEnum;
 
        Out->FeatureType = CAL_FEATURE_TYPE_ENUMERATE;
        Out->FeatureOperationSupport = CAL_FEATURE_SET_OPERATION|CAL_FEATURE_QUERY_OPERATION;
        Out->FeatureModeSupport = CAL_FEATURE_CAMERA_SUPPORT;
        // TODO: add supported flash mode enum here
#ifndef LED_FLASHLIGHT_SUPPORT
        FlashMode->IsSupport = KAL_FALSE;
#else
        FlashMode->IsSupport = KAL_TRUE;
        FlashMode->ItemCount = 2;
        FlashMode->SupportItem[0] = CAM_FLASH_OFF;
        FlashMode->SupportItem[1] = CAM_FLASH_ON;
#endif
    }
    return MM_ERROR_NONE;
}
static MM_ERROR_CODE_ENUM SP0838SensorFeatureCtrl(kal_uint32 Id, void *In, void *Out, kal_uint32 OutLen, kal_uint32 *RealOutLen)
{
  MM_ERROR_CODE_ENUM ErrCode = MM_ERROR_NONE;
  
  if (Id >= CAL_FEATURE_WEBCAM_BEGIN && Id <= CAL_FEATURE_WEBCAM_END)
  {
    return SP0838WebcamFeatureCtrl(Id, In, Out, OutLen, RealOutLen);
  }
  switch (Id)
  {
  /* query and set series */
  case CAL_FEATURE_CAMERA_BRIGHTNESS:
  case CAL_FEATURE_CAMERA_EV_VALUE:
    ErrCode = SP0838Ev(In, Out);
    break;
  case CAL_FEATURE_CAMERA_CONTRAST:
  case CAL_FEATURE_CAMERA_HUE:
  case CAL_FEATURE_CAMERA_SATURATION:
  case CAL_FEATURE_CAMERA_SHARPNESS:
  case CAL_FEATURE_CAMERA_GAMMA:
    ErrCode = MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;
  case CAL_FEATURE_CAMERA_WB:
    ErrCode = SP0838Wb(In, Out);
    break;
  case CAL_FEATURE_CAMERA_IMAGE_EFFECT:
    ErrCode = SP0838Effect(In, Out);
    break;
  case CAL_FEATURE_CAMERA_STILL_CAPTURE_SIZE:
    ErrCode = SP0838StillCaptureSize(In, Out);
    break;
  case CAL_FEATURE_CAMERA_BANDING_FREQ:
    ErrCode = SP0838Banding(In, Out);
    break;
  case CAL_FEATURE_CAMERA_SCENE_MODE:
    ErrCode = SP0838SceneMode(KAL_TRUE, In, Out);
    break;
  case CAL_FEATURE_CAMERA_VIDEO_SCENE_MODE:
    ErrCode = SP0838SceneMode(KAL_FALSE, In, Out);
    break;
    case CAL_FEATURE_CAMERA_FLASH_MODE:
      ErrCode = SP0838FlashMode(In, Out);
      break;
    case IMAGE_SENSOR_FEATURE_QUERY_YUV_CTRL_FLASHLIGHT_TRIGGER_MODE:
        ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = FLASHLIGHT_CONTINUOUS_MODE;
        break;
    case IMAGE_SENSOR_FEATURE_CTRL_FLASHLIGHT:
        FlashlightPowerOn(SP0838Sensor.SensorIdx, ((P_IMAGE_SENSOR_COMM_CTRL_STRUCT)In)->FeatureEnable);
        break;
  
  /* get info series */
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_INFO:
    SP0838GetSensorInfo(Out);
    break;
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_ID:
    ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = SP0838DetectSensorId();
    break;
  case IMAGE_SENSOR_FEATURE_GET_SENSOR_FRAME_RATE:
    ((P_IMAGE_SENSOR_COMM_DATA_STRUCT)Out)->FeatureValue = SP0838Sensor.VideoFps;
    break;
  case IMAGE_SENSOR_FEATURE_GET_INIT_OPERATION_PARA:
    SP0838InitOperationPara(Out);
    break;
  case IMAGE_SENSOR_FEATURE_GET_HW_DEPENDENT_SETTING:
    CamGetHWInfo(SP0838Sensor.SensorIdx, Out);
    break;
  
  /* set para series */
  case IMAGE_SENSOR_FEATURE_SET_SENSOR_POWER_DOWN:
    CamPdnPinCtrl(SP0838Sensor.SensorIdx, 1);
    CamRstPinCtrl(SP0838Sensor.SensorIdx, 0);
    break;
  case IMAGE_SENSOR_FEATURE_SET_NVRAM_SENSOR_INFO:
    SP0838Sensor.NvramData = &(((nvram_camera_para_struct *)In)->SENSOR);
    break;
  case IMAGE_SENSOR_FEATURE_SET_CAMERA_SOURCE:
    SP0838Sensor.SensorIdx = ((P_IMAGE_SENSOR_SET_CAMERA_SOURCE_STRUCT)In)->ImageSensorIdx;
    break;
  case IMAGE_SENSOR_FEATURE_CTRL_NIGHTMODE: /* move to preview */
    break;
  case IMAGE_SENSOR_FEATURE_SET_AE_BYPASS:
    SP0838Sensor.BypassAe = *(kal_bool *)In;
    SP0838AeEnable(SP0838Sensor.BypassAe ? KAL_FALSE : KAL_TRUE);
    break;
  case IMAGE_SENSOR_FEATURE_SET_AWB_BYPASS:
    SP0838Sensor.BypassAwb = *(kal_bool *)In;
    SP0838AwbEnable(SP0838Sensor.BypassAwb ? KAL_FALSE : KAL_TRUE);
    break;
  default:
    ErrCode = MM_ERROR_SENSOR_FEATURE_NOT_SUPPORT;
    break;
  }
  return ErrCode;
}

/*************************************************************************
* FUNCTION
*    SP0838SensorCtrl
*
* DESCRIPTION
*    This function set sensor scenario mode
*
* PARAMETERS
*    Id: scenario id
*    In/Out: parameter
*    OutLen: Out parameter length
*    RealOutLen: Real out parameter length
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838SensorCtrl(CAL_SCENARIO_ENUM Id, void *In, void *Out, kal_uint32 OutLen, kal_uint32 *RealOutLen)
{
  switch (Id)
  {
  case CAL_SCENARIO_CAMERA_PREVIEW:
  case CAL_SCENARIO_VIDEO:
  case CAL_SCENARIO_WEBCAM_PREVIEW:
  case CAL_SCENARIO_WEBCAM_CAPTURE:
    SP0838Preview(Id, In, Out);
    break;
  case CAL_SCENARIO_CAMERA_STILL_CAPTURE:
    SP0838Capture(Id, In, Out);
    break;
  default:
    break;
  }
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838SensorClose
*
* DESCRIPTION
*    This function is to turn off sensor module power.
*
* PARAMETERS
*    None
*
* RETURNS
*    Error code
*
* LOCAL AFFECTED
*
*************************************************************************/
static MM_ERROR_CODE_ENUM SP0838SensorClose(void)
{
    kal_prompt_trace(MOD_MED,"Telacom SP0838SensorClose!");
  CamPdnPinCtrl(SP0838Sensor.SensorIdx, 1);
  CamRstPinCtrl(SP0838Sensor.SensorIdx, 0);
  CisModulePowerOn(SP0838Sensor.SensorIdx, KAL_FALSE);
  CameraSccbClose(CAMERA_SCCB_SENSOR);
  
  return MM_ERROR_NONE;
}

/*************************************************************************
* FUNCTION
*    SP0838SensorFunc
*
* DESCRIPTION
*    This function get sensor function pointer
*
* PARAMETERS
*    sensor function pointer
*
* RETURNS
*    Error code
*
* GLOBALS AFFECTED
*
*************************************************************************/
MM_ERROR_CODE_ENUM SP0838SensorFunc(P_IMAGE_SENSOR_FUNCTION_STRUCT *pfSensorFunc)
{
  static IMAGE_SENSOR_FUNCTION_STRUCT ImageSensorFuncSP0838 =
  {
    SP0838SensorOpen,
    SP0838SensorFeatureCtrl,
    SP0838SensorCtrl,
    SP0838SensorClose,
  };
  *pfSensorFunc = &ImageSensorFuncSP0838;
  
  return MM_ERROR_NONE;
}

