/*****************************************************************************
*  Copyright Statement:
*  --------------------
*  This software is protected by Copyright and the information contained
*  herein is confidential. The software may not be copied and the information
*  contained herein may not be used or disclosed except with the written
*  permission of MediaTek Inc. (C) 2005
*
*  BY OPENING THIS FILE, BUYER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
*  THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("MEDIATEK SOFTWARE")
*  RECEIVED FROM MEDIATEK AND/OR ITS REPRESENTATIVES ARE PROVIDED TO BUYER ON
*  AN "AS-IS" BASIS ONLY. MEDIATEK EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES,
*  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
*  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
*  NEITHER DOES MEDIATEK PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
*  SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
*  SUPPLIED WITH THE MEDIATEK SOFTWARE, AND BUYER AGREES TO LOOK ONLY TO SUCH
*  THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. MEDIATEK SHALL ALSO
*  NOT BE RESPONSIBLE FOR ANY MEDIATEK SOFTWARE RELEASES MADE TO BUYER'S
*  SPECIFICATION OR TO CONFORM TO A PARTICULAR STANDARD OR OPEN FORUM.
*
*  BUYER'S SOLE AND EXCLUSIVE REMEDY AND MEDIATEK'S ENTIRE AND CUMULATIVE
*  LIABILITY WITH RESPECT TO THE MEDIATEK SOFTWARE RELEASED HEREUNDER WILL BE,
*  AT MEDIATEK'S OPTION, TO REVISE OR REPLACE THE MEDIATEK SOFTWARE AT ISSUE,
*  OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY BUYER TO
*  MEDIATEK FOR SUCH MEDIATEK SOFTWARE AT ISSUE. 
*
*  THE TRANSACTION CONTEMPLATED HEREUNDER SHALL BE CONSTRUED IN ACCORDANCE
*  WITH THE LAWS OF THE STATE OF CALIFORNIA, USA, EXCLUDING ITS CONFLICT OF
*  LAWS PRINCIPLES.  ANY DISPUTES, CONTROVERSIES OR CLAIMS ARISING THEREOF AND
*  RELATED THERETO SHALL BE SETTLED BY ARBITRATION IN SAN FRANCISCO, CA, UNDER
*  THE RULES OF THE INTERNATIONAL CHAMBER OF COMMERCE (ICC).
*
*****************************************************************************/

/*****************************************************************************
 *
 * Filename:
 * ---------
 *   image_sensor.c
 *
 * Project:
 * --------
 *   Maui_sw
 *
 * Description:
 * ------------
 *   Image sensor driver function
 *
 * Author:
 * -------
 *   UW Wang (mtk01051)
 *
 *============================================================================
 *             HISTORY
 * Below this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *------------------------------------------------------------------------------
 *
 *------------------------------------------------------------------------------
 * Upper this line, this part is controlled by PVCS VM. DO NOT MODIFY!!
 *============================================================================
 ****************************************************************************/
#include "drv_comm.h"
#include "IntrCtrl.h"
#include "reg_base.h"
#include "gpio_sw.h"
//#include "sccb.h"
#include "isp_if.h"
#include "image_sensor_SP0838.h"
#include "camera_para.h"
#include "upll_ctrl.h"
#include "med_api.h"
#include "sensor_common.h"

#ifndef SP0838_HW_SCCB
#include "sccb.h"
#else
#include "sccb_v2.h"
#endif


//#define __DBG_SENSOR_TRACE__

//global variables
static kal_bool SP0838_VIDEO_MPEG4_QVGA=KAL_FALSE;//Soso Add for QVGA 10fps
static kal_bool SP0838_s_bMPEG4_encode_mode=KAL_FALSE, SP0838_s_bMJPEG_mode = KAL_FALSE; // to distinguish between MPEG4 and MJPEG
static kal_bool  SP0838_s_bNight_mode =KAL_FALSE; // to distinguish night mode or auto mode, default: auto mode setting
static kal_bool  SP0838_s_bSensor_cap_state = KAL_FALSE; // capture or preview mode state
static kal_bool  SP0838_s_bBanding_value = CAM_BANDING_50HZ; // to distinguish between 50HZ and 60HZ.
// Pclk, dummy, exposue related variables.
static kal_uint8  SP0838_preview_pclk_division=0, SP0838_capture_pclk_division=0;
static kal_uint16 SP0838_dummy_pixels=0, SP0838_dummy_lines=0, SP0838_extra_exposure_lines=0;
static kal_uint16 SP0838_exposure_lines=0;
/* Debug Message, Don't Care */
static kal_uint16 SP0838_g_iPV_LinePeriod = 0;
/* Image Sensor ID */
static kal_uint8 SP0838_sensor_id=0;
static kal_uint8 SP0838_banding = 0;//0 for 50hz ,1 for 60hz

void SP0838_set_banding_for_50Hz();
void SP0838_set_banding_for_60Hz();
 
static kal_bool SP0838_sensor_bVideoMode = KAL_FALSE;    // KAL_TRUE for video recorder mode
static kal_bool SP0838_sensor_bCaptureMode = KAL_FALSE;
static kal_bool SP0838_mode_change = KAL_FALSE;
static kal_bool SP0838_night_on = KAL_FALSE;
kal_bool SP0838_sensor_cap_state=KAL_FALSE;

#ifndef SP0838_HW_SCCB

void SP0838_SCCB_send_byte(kal_uint8 send_byte)
{
	volatile signed char i;
	volatile kal_uint32 j;

	for (i=7;i>=0;i--)
	{	/* data bit 7~0 */
		if (send_byte & (1<<i))
		{
			SET_SCCB_DATA_HIGH;
		}
		else
		{
			SET_SCCB_DATA_LOW;
		}
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SET_SCCB_CLK_HIGH;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SET_SCCB_CLK_LOW;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
	}
	/* don't care bit, 9th bit */
	SET_SCCB_DATA_LOW;
	SET_SCCB_DATA_INPUT;
	SET_SCCB_CLK_HIGH;
	for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
//---
#ifdef __DBG_SENSOR_TRACE__
    if (GET_SCCB_DATA_BIT != 0) {
        kal_print_string_trace(MOD_ENG, TRACE_INFO, "WARNING: no ACK!!");
    }
#endif
//---
	SET_SCCB_CLK_LOW;
	SET_SCCB_DATA_OUTPUT;
}	/* SP0838_SCCB_send_byte() */

kal_uint8 SP0838_SCCB_get_byte(void)
{
	volatile signed char i;
	volatile kal_uint32 j;
	kal_uint8 get_byte=0;

	SET_SCCB_DATA_INPUT;
	for (j = 0; j < SP0838_SENSOR_I2C_DELAY; j++); //add this for writing 0x11 register fail

	for (i=7;i>=0;i--)
	{	/* data bit 7~0 */
		SET_SCCB_CLK_HIGH;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		if (GET_SCCB_DATA_BIT)
			get_byte |= (1<<i);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SET_SCCB_CLK_LOW;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
	}
	/* don't care bit, 9th bit */
	SET_SCCB_DATA_OUTPUT;
	SET_SCCB_DATA_HIGH;
	for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
	SET_SCCB_CLK_HIGH;
	for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
	SET_SCCB_CLK_LOW;

	return get_byte;
}	/* SCCB_get_byte() */

#endif




void SP0838_write_cmos_sensor(kal_uint32 addr, kal_uint32 para)
{
	volatile kal_uint32 j;
	//dbg_print("Write %x , Val %x\r\n", addr , para);

#ifdef __DBG_SENSOR_TRACE__
{
    char buff[50];
    sprintf(buff, "write(%x, %x)", addr, para);
    kal_print_string_trace(MOD_ENG, TRACE_INFO, buff);
}
#endif

	#ifdef SP0838_HW_SCCB
	#if 0
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
	#endif
	 SCCB_TRANSACTION_RESULT rt;
	kal_uint8 write_buff[2];
	
	write_buff[0] = addr;
	write_buff[1] = para;
	
	rt = i2c_write(SCCB_OWNER_CAMERA, write_buff, sizeof(write_buff));
	#ifdef SP0838_DBG_TRACE
            if (rt == SCCB_TRANSACTION_FAIL) 
				kal_print_string_trace(MOD_ENG, TRACE_WARNING, "I2C write %x, %x error", addr, para);
        #endif
	#else
		SP0838_I2C_START_TRANSMISSION;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_SCCB_send_byte(SP0838_WRITE_ID);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_SCCB_send_byte(addr);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_SCCB_send_byte(para);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_I2C_STOP_TRANSMISSION;
	#endif /* SP0838_HW_SCCB */

}	/* SP0838_write_cmos_sensor() */

kal_uint32 SP0838_read_cmos_sensor(kal_uint32 addr)
{
	volatile kal_uint32 j;
	kal_uint8 get_byte=0;
#ifdef __DBG_SENSOR_TRACE__
{
    char buff[50];
    sprintf(buff, "read(%x)", addr);
    kal_print_string_trace(MOD_ENG, TRACE_INFO, buff);
}
#endif

	#ifdef SP0838_HW_SCCB
	#if 0
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
/* under construction !*/
	#else
    SCCB_TRANSACTION_RESULT rt;
	kal_uint8 write_buff[1] = {0xFF};
	kal_uint8 read_buff[1];
	
	write_buff[0]=(kal_uint8)(addr&0xff);
    rt = i2c_write(SCCB_OWNER_CAMERA,write_buff,1);
    rt = i2c_read(SCCB_OWNER_CAMERA,read_buff,1);
    get_byte=read_buff[0];
   
	    #ifdef SP0838_DBG_TRACE
  		    if (rt == SCCB_TRANSACTION_FAIL) 
			    kal_print_string_trace(MOD_ENG, TRACE_WARNING, "I2C read %x error", addr);
	    #endif
	#endif
	#else
		SP0838_I2C_START_TRANSMISSION;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_SCCB_send_byte(SP0838_WRITE_ID);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_SCCB_send_byte(addr);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_I2C_STOP_TRANSMISSION;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_I2C_START_TRANSMISSION;
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_SCCB_send_byte(SP0838_READ_ID);
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		get_byte=SP0838_SCCB_get_byte();
		for(j=0;j<SP0838_SENSOR_I2C_DELAY;j++);
		SP0838_I2C_STOP_TRANSMISSION;
	#endif

	return get_byte;
}	/* SP0838_read_cmos_sensor() */

void SP0838_write_shutter(kal_uint16 shutter)
{
       SP0838_write_cmos_sensor(0xfd,0x00);/*page 0*/
	SP0838_write_cmos_sensor(0x04,shutter&0x00FF);//8lsb
	SP0838_write_cmos_sensor(0x03,(shutter&0x0F00)>>8);//4msb							// AEC[b10]/AEC[b15~b10]
}	/* write_SP0838_shutter */

kal_uint32 SP0838_read_shutter(void)
{
	kal_uint8 temp_reg1, temp_reg2;
	kal_uint16 shutter;
	SP0838_write_cmos_sensor(0xfd,0x00);/*page 0*/
	temp_reg1= SP0838_read_cmos_sensor(0x04);
	temp_reg2= SP0838_read_cmos_sensor(0x03);
	shutter=((temp_reg2&0x0f)<<8)|(temp_reg1);
	SP0838_exposure_lines=shutter;
	return  SP0838_exposure_lines;
}	/* read_SP0838_shutter */

void SP0838_write_gain(kal_uint16 gain)
{
}  /* write_SP0838_gain */

kal_uint16 SP0838_read_gain(void)
{
}  /* read_SP0838_gain */

void SP0838_set_dummy(kal_uint16 pixels, kal_uint16 lines)
{
     SP0838_write_cmos_sensor(0xfd,0x00);//page 0       
	 SP0838_write_cmos_sensor(0x09,(pixels&0x0F00)>>8);//4MSB
	 SP0838_write_cmos_sensor(0x0a,pixels&0x00FF);//8lsb
	 SP0838_write_cmos_sensor(0x05,(lines&0x0F00)>>8);
	 SP0838_write_cmos_sensor(0x06,lines&0x00FF);

}	/* set_SP0838_dummy */

/*************************************************************************
* FUNCTION
*	config_SP0838_window
*
* DESCRIPTION
*	This function config the hardware window of SP0838 for getting specified
*  data of that window.
*
* PARAMETERS
*	start_x : start column of the interested window
*  start_y : start row of the interested window
*  width  : column widht of the itnerested window
*  height : row depth of the itnerested window
*
* RETURNS
*	the data that read from SP0838
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_config_window(kal_uint16 startx,kal_uint16 starty,kal_uint16 width, kal_uint16 height)
{
        SP0838_write_cmos_sensor(0xfd,0x00);//page 0
	// Horizontal
	 SP0838_write_cmos_sensor(0x4b,(startx&0x0300)>>8);	       //2msb
	 SP0838_write_cmos_sensor(0x4c,startx&0x00FF);			// 8lsb
	 SP0838_write_cmos_sensor(0x4d,(width&0x0300)>>8);	       //2msb
	 SP0838_write_cmos_sensor(0x4e,width&0x00FF);			// 8lsb
	// Vertical
	 SP0838_write_cmos_sensor(0x47,(starty&0x0100)>>8);	       //1msb
	 SP0838_write_cmos_sensor(0x48,starty&0x00FF);   			// 8lsb
	 SP0838_write_cmos_sensor(0x49,(height&0x0100)>>8);	       // 1msb
	 SP0838_write_cmos_sensor(0x4a,height&0x00FF);		   	// 8lsb

}	/* config_SP0838_window */

void SP0838_init_setting(void)
{
SP0838_write_cmos_sensor(0xfd , 0x00); //P0
SP0838_write_cmos_sensor(0x1B , 0x02);
SP0838_write_cmos_sensor(0x27 , 0xe8);
SP0838_write_cmos_sensor(0x28 , 0x0B);
SP0838_write_cmos_sensor(0x32 , 0x00);
SP0838_write_cmos_sensor(0x22 , 0xc0);
SP0838_write_cmos_sensor(0x26 , 0x10); 

  if(mmi_camera_get_direction()==0) //main camera 
    {
        SP0838_write_cmos_sensor(0x31 , 0x10);   //Upside/mirr/Pclk inv/sub
        dbg_print("SP0838_mian_mirr_unside_set\r\n");
    }
    else//aub camera 
    {
        SP0838_write_cmos_sensor(0x31 , 0x50);   //Upside/mirr/Pclk inv/sub
        dbg_print("SP0838_aub_mirr_unside_set\r\n");
    }

SP0838_write_cmos_sensor(0x5f , 0x11);   //Bayer order
SP0838_write_cmos_sensor(0xfd , 0x01);   //P1
SP0838_write_cmos_sensor(0x25 , 0x1a);   //Awb start
SP0838_write_cmos_sensor(0x26 , 0xfb); 
SP0838_write_cmos_sensor(0x28 , 0x75); 
SP0838_write_cmos_sensor(0x29 , 0x4e);
SP0838_write_cmos_sensor(0xfd , 0x00);   
SP0838_write_cmos_sensor(0xe7 , 0x03); 
SP0838_write_cmos_sensor(0xe7 , 0x00); 
SP0838_write_cmos_sensor(0xfd , 0x01);

SP0838_write_cmos_sensor(0x31 , 0x60);//64
SP0838_write_cmos_sensor(0x32 , 0x18);
SP0838_write_cmos_sensor(0x4d , 0xdc);
SP0838_write_cmos_sensor(0x4e , 0x53);
SP0838_write_cmos_sensor(0x41 , 0x8c);
SP0838_write_cmos_sensor(0x42 , 0x57);
SP0838_write_cmos_sensor(0x55 , 0xff);
SP0838_write_cmos_sensor(0x56 , 0x00);
SP0838_write_cmos_sensor(0x59 , 0x82);
SP0838_write_cmos_sensor(0x5a , 0x00);
SP0838_write_cmos_sensor(0x5d , 0xff);
SP0838_write_cmos_sensor(0x5e , 0x6f);
SP0838_write_cmos_sensor(0x57 , 0xff);
SP0838_write_cmos_sensor(0x58 , 0x00);
SP0838_write_cmos_sensor(0x5b , 0xff);
SP0838_write_cmos_sensor(0x5c , 0xa8);
SP0838_write_cmos_sensor(0x5f , 0x75);
SP0838_write_cmos_sensor(0x60 , 0x00);
SP0838_write_cmos_sensor(0x2d , 0x00);
SP0838_write_cmos_sensor(0x2e , 0x00);
SP0838_write_cmos_sensor(0x2f , 0x00);
SP0838_write_cmos_sensor(0x30 , 0x00);
SP0838_write_cmos_sensor(0x33 , 0x00);
SP0838_write_cmos_sensor(0x34 , 0x00);
SP0838_write_cmos_sensor(0x37 , 0x00);
SP0838_write_cmos_sensor(0x38 , 0x00);  //awb end
SP0838_write_cmos_sensor(0xfd , 0x00);  //P0
SP0838_write_cmos_sensor(0x33 , 0x6f);  //LSC BPC EN
SP0838_write_cmos_sensor(0x51 , 0x3f);  //BPC debug start
SP0838_write_cmos_sensor(0x52 , 0x09);  
SP0838_write_cmos_sensor(0x53 , 0x00);  
SP0838_write_cmos_sensor(0x54 , 0x00);
SP0838_write_cmos_sensor(0x55 , 0x10);  //BPC debug end
SP0838_write_cmos_sensor(0x4f , 0x08);  //blueedge
SP0838_write_cmos_sensor(0x50 , 0x08);
SP0838_write_cmos_sensor(0x57 , 0x10);  //Raw filter debut start
SP0838_write_cmos_sensor(0x58 , 0x10);
SP0838_write_cmos_sensor(0x59 , 0x10);
SP0838_write_cmos_sensor(0x56 , 0x70);
SP0838_write_cmos_sensor(0x5a , 0x02);
SP0838_write_cmos_sensor(0x5b , 0x02);
SP0838_write_cmos_sensor(0x5c , 0x20);  //Raw filter debut end 
SP0838_write_cmos_sensor(0x65 , 0x03);  //Sharpness debug start
SP0838_write_cmos_sensor(0x66 , 0x01);
SP0838_write_cmos_sensor(0x67 , 0x03);
SP0838_write_cmos_sensor(0x68 , 0x46);
SP0838_write_cmos_sensor(0x69 , 0x7f);
SP0838_write_cmos_sensor(0x6a , 0x01);
SP0838_write_cmos_sensor(0x6b , 0x04);
SP0838_write_cmos_sensor(0x6c , 0x01);
SP0838_write_cmos_sensor(0x6d , 0x03);  //Edge gain normal
SP0838_write_cmos_sensor(0x6e , 0x46);  //Edge gain normal
SP0838_write_cmos_sensor(0x6f , 0x7f);
SP0838_write_cmos_sensor(0x70 , 0x01);
SP0838_write_cmos_sensor(0x71 , 0x05);   //ֵ          
SP0838_write_cmos_sensor(0x72 , 0x01);   //ֵ        
SP0838_write_cmos_sensor(0x73 , 0x03);   //Եֵ    
SP0838_write_cmos_sensor(0x74 , 0x46);   //Եֵ    
SP0838_write_cmos_sensor(0x75 , 0x7f);   //ʹλ            
SP0838_write_cmos_sensor(0x76 , 0x01);  
SP0838_write_cmos_sensor(0xcb , 0x07);  //HEQ&Saturation debug start 
SP0838_write_cmos_sensor(0xcc , 0x04);
SP0838_write_cmos_sensor(0xce , 0xff);
SP0838_write_cmos_sensor(0xcf , 0x10);
SP0838_write_cmos_sensor(0xd0 , 0x20);
SP0838_write_cmos_sensor(0xd1 , 0x00);
SP0838_write_cmos_sensor(0xd2 , 0x1c);
SP0838_write_cmos_sensor(0xd3 , 0x16);
SP0838_write_cmos_sensor(0xd4 , 0x00);
SP0838_write_cmos_sensor(0xd6 , 0x1c);
SP0838_write_cmos_sensor(0xd7 , 0x16);
SP0838_write_cmos_sensor(0xdd , 0x70);  //Contrast
SP0838_write_cmos_sensor(0xde , 0x90);  //HEQ&Saturation debug end
SP0838_write_cmos_sensor(0x7f , 0xd7);  //Color Correction start
SP0838_write_cmos_sensor(0x80 , 0xbc);                          
SP0838_write_cmos_sensor(0x81 , 0xed);                          
SP0838_write_cmos_sensor(0x82 , 0xd7);                          
SP0838_write_cmos_sensor(0x83 , 0xd4);                          
SP0838_write_cmos_sensor(0x84 , 0xd6);                          
SP0838_write_cmos_sensor(0x85 , 0xff);                          
SP0838_write_cmos_sensor(0x86 , 0x89);                          
SP0838_write_cmos_sensor(0x87 , 0xf8);                          
SP0838_write_cmos_sensor(0x88 , 0x3c);                          
SP0838_write_cmos_sensor(0x89 , 0x33);                          
SP0838_write_cmos_sensor(0x8a , 0x0f);  //Color Correction end 
SP0838_write_cmos_sensor(0x8b , 0x00);  //gamma start
SP0838_write_cmos_sensor(0x8c , 0x1a);               
SP0838_write_cmos_sensor(0x8d , 0x29);               
SP0838_write_cmos_sensor(0x8e , 0x41);               
SP0838_write_cmos_sensor(0x8f , 0x62);               
SP0838_write_cmos_sensor(0x90 , 0x7c);               
SP0838_write_cmos_sensor(0x91 , 0x90);               
SP0838_write_cmos_sensor(0x92 , 0xa2);               
SP0838_write_cmos_sensor(0x93 , 0xaf);               
SP0838_write_cmos_sensor(0x94 , 0xbc);               
SP0838_write_cmos_sensor(0x95 , 0xc5);               
SP0838_write_cmos_sensor(0x96 , 0xcd);               
SP0838_write_cmos_sensor(0x97 , 0xd5);               
SP0838_write_cmos_sensor(0x98 , 0xdd);               
SP0838_write_cmos_sensor(0x99 , 0xe5);               
SP0838_write_cmos_sensor(0x9a , 0xed);               
SP0838_write_cmos_sensor(0x9b , 0xf5);               
SP0838_write_cmos_sensor(0xfd , 0x01);  //P1         
SP0838_write_cmos_sensor(0x8d , 0xfd);               
SP0838_write_cmos_sensor(0x8e , 0xff);  //gamma end  
SP0838_write_cmos_sensor(0xfd , 0x00);  //P0
SP0838_write_cmos_sensor(0xca , 0xcf);
SP0838_write_cmos_sensor(0xd8 , 0x48);  //UV outdoor
SP0838_write_cmos_sensor(0xd9 , 0x48);  //UV indoor 
SP0838_write_cmos_sensor(0xda , 0x48);  //UV dummy
SP0838_write_cmos_sensor(0xdb , 0x48);  //UV lowlight
SP0838_write_cmos_sensor(0xb9 , 0x00);  //Ygamma start
SP0838_write_cmos_sensor(0xba , 0x04);
SP0838_write_cmos_sensor(0xbb , 0x08);
SP0838_write_cmos_sensor(0xbc , 0x10);
SP0838_write_cmos_sensor(0xbd , 0x20);
SP0838_write_cmos_sensor(0xbe , 0x30);
SP0838_write_cmos_sensor(0xbf , 0x40);
SP0838_write_cmos_sensor(0xc0 , 0x50);
SP0838_write_cmos_sensor(0xc1 , 0x60);
SP0838_write_cmos_sensor(0xc2 , 0x70);
SP0838_write_cmos_sensor(0xc3 , 0x80);
SP0838_write_cmos_sensor(0xc4 , 0x90);
SP0838_write_cmos_sensor(0xc5 , 0xA0);
SP0838_write_cmos_sensor(0xc6 , 0xB0);
SP0838_write_cmos_sensor(0xc7 , 0xC0);
SP0838_write_cmos_sensor(0xc8 , 0xD0);
SP0838_write_cmos_sensor(0xc9 , 0xE0);
SP0838_write_cmos_sensor(0xfd , 0x01);  //P1
SP0838_write_cmos_sensor(0x89 , 0xf0);
SP0838_write_cmos_sensor(0x8a , 0xff);  //Ygamma end
SP0838_write_cmos_sensor(0xfd , 0x00);  //P0
SP0838_write_cmos_sensor(0xe8 , 0x30);  //AEdebug start
SP0838_write_cmos_sensor(0xe9 , 0x30);
SP0838_write_cmos_sensor(0xea , 0x40);  //Alc Window sel
SP0838_write_cmos_sensor(0xf4 , 0x1b);  //outdoor mode sel
SP0838_write_cmos_sensor(0xf5 , 0x80);
SP0838_write_cmos_sensor(0xf7 , 0x78);  //AE target
SP0838_write_cmos_sensor(0xf8 , 0x63);  
SP0838_write_cmos_sensor(0xf9 , 0x68);  //AE target
SP0838_write_cmos_sensor(0xfa , 0x53);
SP0838_write_cmos_sensor(0xfd , 0x01);  //P1
SP0838_write_cmos_sensor(0x09 , 0x31);  //AE Step 3.0
SP0838_write_cmos_sensor(0x0a , 0x85);
SP0838_write_cmos_sensor(0x0b , 0x0b);  //AE Step 3.0
SP0838_write_cmos_sensor(0x14 , 0x20);
SP0838_write_cmos_sensor(0x15 , 0x0f);
SP0838_write_cmos_sensor(0xfd , 0x00);  //P0
SP0838_write_cmos_sensor(0x05 , 0x00);  
SP0838_write_cmos_sensor(0x06 , 0x00);
SP0838_write_cmos_sensor(0x09 , 0x01);
SP0838_write_cmos_sensor(0x0a , 0x76);
SP0838_write_cmos_sensor(0xf0 , 0x62);
SP0838_write_cmos_sensor(0xf1 , 0x00);
SP0838_write_cmos_sensor(0xf2 , 0x5f);
SP0838_write_cmos_sensor(0xf5 , 0x78);
SP0838_write_cmos_sensor(0xfd , 0x01);  //P1
SP0838_write_cmos_sensor(0x00 , 0xba);
SP0838_write_cmos_sensor(0x0f , 0x60);
SP0838_write_cmos_sensor(0x16 , 0x60);
SP0838_write_cmos_sensor(0x17 , 0xa2);
SP0838_write_cmos_sensor(0x18 , 0xaa);
SP0838_write_cmos_sensor(0x1b , 0x60);
SP0838_write_cmos_sensor(0x1c , 0xaa);
SP0838_write_cmos_sensor(0xb4 , 0x20);
SP0838_write_cmos_sensor(0xb5 , 0x3a);
SP0838_write_cmos_sensor(0xb6 , 0x5e);
SP0838_write_cmos_sensor(0xb9 , 0x40);
SP0838_write_cmos_sensor(0xba , 0x4f);
SP0838_write_cmos_sensor(0xbb , 0x47);
SP0838_write_cmos_sensor(0xbc , 0x45);
SP0838_write_cmos_sensor(0xbd , 0x43);
SP0838_write_cmos_sensor(0xbe , 0x42);
SP0838_write_cmos_sensor(0xbf , 0x42);
SP0838_write_cmos_sensor(0xc0 , 0x42);
SP0838_write_cmos_sensor(0xc1 , 0x41);
SP0838_write_cmos_sensor(0xc2 , 0x41);
SP0838_write_cmos_sensor(0xc3 , 0x41);
SP0838_write_cmos_sensor(0xc4 , 0x41);
SP0838_write_cmos_sensor(0xc5 , 0x78);
SP0838_write_cmos_sensor(0xc6 , 0x41);
SP0838_write_cmos_sensor(0xca , 0x78);
SP0838_write_cmos_sensor(0xcb , 0x0c);  //AEdebug end

#if 1//caprure preview daylight 24M 50hz 20-8FPS maxgain:0x70	
SP0838_write_cmos_sensor(0xfd , 0x00);
SP0838_write_cmos_sensor(0x05 , 0x0 );
SP0838_write_cmos_sensor(0x06 , 0x0 );
SP0838_write_cmos_sensor(0x09 , 0x1 );
SP0838_write_cmos_sensor(0x0a , 0x76);
SP0838_write_cmos_sensor(0xf0 , 0x62);
SP0838_write_cmos_sensor(0xf1 , 0x0 );
SP0838_write_cmos_sensor(0xf2 , 0x5f);
SP0838_write_cmos_sensor(0xf5 , 0x78);
SP0838_write_cmos_sensor(0xfd , 0x01);
SP0838_write_cmos_sensor(0x00 , 0xb2);
SP0838_write_cmos_sensor(0x0f , 0x60);
SP0838_write_cmos_sensor(0x16 , 0x60);
SP0838_write_cmos_sensor(0x17 , 0xa2);
SP0838_write_cmos_sensor(0x18 , 0xaa);
SP0838_write_cmos_sensor(0x1b , 0x60);
SP0838_write_cmos_sensor(0x1c , 0xaa);
SP0838_write_cmos_sensor(0xb4 , 0x20);
SP0838_write_cmos_sensor(0xb5 , 0x3a);
SP0838_write_cmos_sensor(0xb6 , 0x5e);
SP0838_write_cmos_sensor(0xb9 , 0x40);
SP0838_write_cmos_sensor(0xba , 0x4f);
SP0838_write_cmos_sensor(0xbb , 0x47);
SP0838_write_cmos_sensor(0xbc , 0x45);
SP0838_write_cmos_sensor(0xbd , 0x43);
SP0838_write_cmos_sensor(0xbe , 0x42);
SP0838_write_cmos_sensor(0xbf , 0x42);
SP0838_write_cmos_sensor(0xc0 , 0x42);
SP0838_write_cmos_sensor(0xc1 , 0x41);
SP0838_write_cmos_sensor(0xc2 , 0x41);
SP0838_write_cmos_sensor(0xc3 , 0x41);
SP0838_write_cmos_sensor(0xc4 , 0x41);
SP0838_write_cmos_sensor(0xc5 , 0x70);
SP0838_write_cmos_sensor(0xc6 , 0x41);
SP0838_write_cmos_sensor(0xca , 0x70);
SP0838_write_cmos_sensor(0xcb , 0xc );
SP0838_write_cmos_sensor(0xfd , 0x00);
#endif	

SP0838_write_cmos_sensor(0xfd , 0x00);  //P0
SP0838_write_cmos_sensor(0x32 , 0x15);  //Auto_mode set
SP0838_write_cmos_sensor(0x34 , 0x66);  //Isp_mode set
SP0838_write_cmos_sensor(0x35 , 0x00);  //out format
}


#ifdef SP0838_HW_SCCB
/*
static kal_bool SP0838_Config_HW_SCCB(void)
{
	sccb_config_struct config;
  
	config.sccb_mode= SCCB_HW_8BIT ; 	 
	config.get_handle_wait=KAL_TRUE;	 
	config.slave_address= SP0838_SCCB_SLAVE_ADDR; 
	config.delay_len = 0;
	config.transaction_mode=SCCB_TRANSACTION_FAST_MODE;
	config.Fast_Mode_Speed=SP0838_SCCB_FAST_MODE_SPEED;	//The speed of sccb fast mode(Kb)
  
	i2c_config(SCCB_OWNER_CAMERA, &config);
}
*/
#endif

#define MODULE_RESET_PIN		(60|0x80)


/*************************************************************************
* FUNCTION
*	init_SP0838
*
* DESCRIPTION
*	This function initialize the registers of CMOS sensor and ISP control register.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_int8 SP0838_init(void)
{
    kal_uint16 i = 0;

    
	cis_module_power_on(KAL_TRUE);      // Power On CIS Power
	kal_sleep_task(2);				    // To wait for Stable Power, at least 5ms
//	RESET_CMOS_SENSOR_MODE2;			// High - normal, Low - reset, SP0838 don't support hardware reset

	SP0838_PWRDN_PIN_LOW;//open cmos sensor
	kal_sleep_task(2);	
      	/* Reset the sensor */
	SP0838_RESET_PIN_HIGH;
	kal_sleep_task(2); 
	SP0838_RESET_PIN_LOW;
	kal_sleep_task(2);   
	SP0838_RESET_PIN_HIGH;
       /* Sensor Signal Polarity */

	SET_CMOS_CLOCK_POLARITY_LOW;
	SET_VSYNC_POLARITY_HIGH;	//SET_VSYNC_POLARITY_LOW	//yud for green screen 2010-08-09
	SET_HSYNC_POLARITY_LOW;    
	ENABLE_CAMERA_INDATA_FORMAT;
	SET_CAMERA_INPUT_TYPE(INPUT_YUV422);
	SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);
#if (defined(DRV_ISP_6238_SERIES))  
		setCameraCPLLOutputFreq(48000000);
#endif
	ENABLE_CAMERA_TG_CLK_48M;
#if (!defined(DRV_ISP_6238_SERIES))  
	UPLL_Enable(UPLL_OWNER_ISP); 
#endif  
    /* config TG of ISP to match the setting of image sensor*/
	SET_TG_OUTPUT_CLK_DIVIDER(1); //for mt6253 and mt6268, video and cemera preview/capture will use the same clock
	SET_CMOS_RISING_EDGE(0);
	SET_CMOS_FALLING_EDGE(1);
	ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	SET_TG_PIXEL_CLK_DIVIDER(1);
	SET_CMOS_DATA_LATCH(1);
	
#if (defined(MT6253D_EVB))
	set_isp_driving_current(ISP_DRIVING_2MA);
#else
	set_isp_driving_current(ISP_DRIVING_8MA);
#endif

   #ifdef SP0838_HW_SCCB
      i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
	  i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0838_WRITE_ID);
	  i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_300KB);
	   //  SP0838_Config_HW_SCCB();
		// kal_sleep_task(1); 
#endif

	
		SP0838_write_cmos_sensor(0xfd, 0x00);
		SP0838_sensor_id= SP0838_read_cmos_sensor(0x02);
		dbg_print("SP0838_init Read Sensor ID is %x\r\n", SP0838_sensor_id);
		kal_sleep_task(10); 
		
	if(SP0838_sensor_id != SP0838_SENSOR_ID)
		return -1;

	// Initail Sequence Write In.
       SP0838_init_setting();
	return 1;
}	/* init_cmos_sensor() */

/*************************************************************************
* FUNCTION
*	init_SP0838
*
* DESCRIPTION
*	This function initialize the registers of CMOS sensor and ISP control register.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
image_sensor_func_struct image_sensor_func_SP0838;

extern unsigned char  camra_select_main_or_sub_sys_value;

kal_uint32 SP0838_detect_sensor_id(void)
{
    kal_uint16 i = 0;
	unsigned char Tmp = 0;

	dbg_print("SP0838_detect_sensor_id \r\n");

	Tmp = camra_select_main_or_sub_sys_value;
	camra_select_main_or_sub_sys_value = 0;
	cis_module_power_on(KAL_TRUE);      // Power On CIS Power
	camra_select_main_or_sub_sys_value = Tmp;
	kal_sleep_task(2);				    // To wait for Stable Power, at least 5ms
//	RESET_CMOS_SENSOR_MODE2;			// High - normal, Low - reset, SP0838 don't support hardware reset
#if 1//zch 2010-12-17
	SP0838_PWRDN_PIN_LOW;//open cmos sensor
	kal_sleep_task(2);	
	/* Reset the sensor */
	SP0838_RESET_PIN_HIGH;
	kal_sleep_task(2); 
	SP0838_RESET_PIN_LOW;
	kal_sleep_task(2);   
	SP0838_RESET_PIN_HIGH;
#endif
	SET_CMOS_CLOCK_POLARITY_LOW;
	SET_VSYNC_POLARITY_LOW;
	SET_HSYNC_POLARITY_LOW;    
	ENABLE_CAMERA_INDATA_FORMAT;
	SET_CAMERA_INPUT_TYPE(INPUT_YUV422);
	SET_CAMERA_INPUT_ORDER(INPUT_ORDER_CbYCrY1);
#if (defined(DRV_ISP_6238_SERIES))  
	setCameraCPLLOutputFreq(48000000);
#endif
	ENABLE_CAMERA_TG_CLK_48M;
#if (!defined(DRV_ISP_6238_SERIES))  
	UPLL_Enable(UPLL_OWNER_ISP);  
#endif
    /* config TG of ISP to match the setting of image sensor*/
	SET_TG_OUTPUT_CLK_DIVIDER(1); //for mt6253 and mt6268, video and cemera preview/capture will use the same clock
	SET_CMOS_RISING_EDGE(0);
	SET_CMOS_FALLING_EDGE(1);
	ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	SET_TG_PIXEL_CLK_DIVIDER(1);
	SET_CMOS_DATA_LATCH(1);
	
	set_isp_driving_current(ISP_DRIVING_8MA);

#ifdef SP0838_HW_SCCB
		//   SP0838_Config_HW_SCCB();
		//   kal_sleep_task(1); 
      i2c_set_get_handle_wait(SCCB_OWNER_CAMERA, KAL_TRUE);
	  i2c_set_slave_address(SCCB_OWNER_CAMERA, SP0838_WRITE_ID);
	  i2c_set_transaction_mode(SCCB_OWNER_CAMERA, SCCB_TRANSACTION_FAST_MODE, SCCB_300KB);
	   //  SP0838_Config_HW_SCCB();
		// kal_sleep_task(1); 
#endif
//    POWER_OFF_CMOS_SENSOR;
	POWER_ON_CMOS_SENSOR; //power down pin is low active when sensor work
    kal_sleep_task(3); //it should wait at least 10ms before starting I2C
	
    	SP0838_write_cmos_sensor(0xfd, 0x00);
    	SP0838_sensor_id= SP0838_read_cmos_sensor(0x02);
		dbg_print("%d Read Sensor ID is %x\r\n", i, SP0838_sensor_id);
#ifdef __DBG_SENSOR_TRACE__
        kal_print_string_trace(MOD_ENG, TRACE_INFO, "SP0838_detect_sensor_id SP0838_sensor_id=%x", SP0838_sensor_id);
#endif

       if(SP0838_sensor_id == SP0838_SENSOR_ID)
       return SP0838_sensor_id;
       else
       return 0;
}	/* SP0838_detect_sensor_id() */

/*************************************************************************
* FUNCTION
*	power_off_SP0838
*
* DESCRIPTION
*	This function is to turn off sensor module power.
*
* PARAMETERS
*	None
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/

void SP0838_power_off(void)
{
  //  MY_CAM_TRACE_HEAD_0(SP0838_power_off);
	cis_module_power_on(KAL_FALSE);      // Power Off CIS Power
	UPLL_Disable(UPLL_OWNER_ISP);
	#ifndef SP0838_HW_SCCB
	   SET_SCCB_CLK_LOW;
	   SET_SCCB_DATA_LOW;
	#endif
}	/* power_off_SP0838 */

/*************************************************************************
* FUNCTION
*	get_SP0838_id
*
* DESCRIPTION
*	This function return the sensor read/write id of SCCB interface.
*
* PARAMETERS
*	*sensor_write_id : address pointer of sensor write id
*  *sensor_read_id  : address pointer of sensor read id
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_get_id(kal_uint8 *sensor_write_id, kal_uint8 *sensor_read_id)
{
	*sensor_write_id=SP0838_WRITE_ID;
	*sensor_read_id=SP0838_READ_ID;
}	/* get_SP0838_id */

/*************************************************************************
* FUNCTION
*	get_SP0838_size
*
* DESCRIPTION
*	This function return the image width and height of image sensor.
*
* PARAMETERS
*	*sensor_width : address pointer of horizontal effect pixels of image sensor
*  *sensor_height : address pointer of vertical effect pixels of image sensor
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_get_size(kal_uint16 *sensor_width, kal_uint16 *sensor_height)
{
	*sensor_width=SP0838_IMAGE_SENSOR_VGA_WIDTH;			/* pixel numbers actually used in one frame */
	*sensor_height=SP0838_IMAGE_SENSOR_VGA_HEIGHT;		/* line numbers actually used in one frame */
}	/* get_SP0838_size */

/*************************************************************************
* FUNCTION
*	get_SP0838_period
*
* DESCRIPTION
*	This function return the image width and height of image sensor.
*
* PARAMETERS
*	*pixel_number : address pointer of pixel numbers in one period of HSYNC
*  *line_number : address pointer of line numbers in one period of VSYNC
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_get_period(kal_uint16 *pixel_number, kal_uint16 *line_number)
{
	*pixel_number=SP0838_VGA_PERIOD_PIXEL_NUMS;		/* pixel numbers in one period of HSYNC */
	*line_number=SP0838_VGA_PERIOD_LINE_NUMS;			/* line numbers in one period of VSYNC */
}	/* get_SP0838_period */


void SP0838_preview(image_sensor_exposure_window_struct *image_window, image_sensor_config_struct *sensor_config_data)
{
	kal_uint8 iHV_Mirror = 0;
	kal_uint8 iStartX = 0, iStartY = 1;
	kal_uint8 iTemp = 0;
	volatile kal_uint16 iRetry;
	static kal_uint16 iBound = 0x00FF;
	kal_bool video_mode = 0;
	//kal_prompt_trace(MOD_MED_C,"SP0838_Preview------------------");

	SP0838_sensor_cap_state=KAL_FALSE;

	 SP0838_write_cmos_sensor(0xfd, 0x00);



	if (sensor_config_data->isp_op_mode == ISP_MJPEG_PREVIEW_MODE || sensor_config_data->isp_op_mode == ISP_MJPEG_ENCODE_MODE
		|| (sensor_config_data->frame_rate==0x0F)) 
	{ // MJPEG mode
		video_mode = KAL_TRUE;

		#if 0// Video Ƶ

			 /* config TG of ISP to match the setting of image sensor*/
			SET_TG_OUTPUT_CLK_DIVIDER(3);	
			SET_CMOS_RISING_EDGE(0);
			SET_CMOS_FALLING_EDGE(2);
			ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
			SET_TG_PIXEL_CLK_DIVIDER(3);
			SET_CMOS_DATA_LATCH(2); 	
		#else
		SET_TG_OUTPUT_CLK_DIVIDER(1);	
		SET_CMOS_RISING_EDGE(0);
		SET_CMOS_FALLING_EDGE(1);
		ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
		SET_TG_PIXEL_CLK_DIVIDER(1);
		SET_CMOS_DATA_LATCH(1);		
		#endif
	}
	else 
	{
		video_mode = KAL_FALSE;
		SP0838_sensor_bCaptureMode = KAL_FALSE;
		/* config TG of ISP to match the setting of image sensor*/
		SET_TG_OUTPUT_CLK_DIVIDER(1);	
		SET_CMOS_RISING_EDGE(0);
		SET_CMOS_FALLING_EDGE(1);
		ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
		SET_TG_PIXEL_CLK_DIVIDER(1);
		SET_CMOS_DATA_LATCH(1);
	}

        if (video_mode != SP0838_sensor_bVideoMode)
        {
           SP0838_sensor_bVideoMode = video_mode;
           SP0838_mode_change = KAL_TRUE;
        }

	image_window->grab_start_x = iStartX;
	image_window->grab_start_y = iStartY;
	image_window->exposure_window_width = SP0838_IMAGE_SENSOR_VGA_WIDTH - iStartX;
	image_window->exposure_window_height = SP0838_IMAGE_SENSOR_VGA_HEIGHT - iStartY;
	
	//SP0838_write_cmos_sensor(0x03, 0x00);
	kal_sleep_task(30);	
}	/* SP0838_preview */

void SP0838_capture(image_sensor_exposure_window_struct *image_window, image_sensor_config_struct *sensor_config_data)
{
	kal_uint8 iStartX = 0, iStartY = 1, iTemp;
	kal_uint32  SP0838_iExp_ini2;
	//  kal_uint32  SP0838_iExp_ini;	

	//kal_prompt_trace(MOD_MED_C," SP0838_capture------------------BEGIN");

	SP0838_sensor_cap_state = KAL_TRUE;
	SP0838_sensor_bCaptureMode = KAL_TRUE;

	if (sensor_config_data->frame_rate == 0xF0) 
	{
		/************************************
		*   Webcam mode, AE/AWB still on    *
		************************************/
               //SP0838_set_dummy(0x0132, 0x0070);
		 /* config TG of ISP to match the setting of image sensor*/
	        SET_TG_OUTPUT_CLK_DIVIDER(3);	
	        SET_CMOS_RISING_EDGE(0);
	        SET_CMOS_FALLING_EDGE(2);
	        ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	        SET_TG_PIXEL_CLK_DIVIDER(3);
	        SET_CMOS_DATA_LATCH(2);
	}
	else
	{
		   /* config TG of ISP to match the setting of image sensor*/
	        SET_TG_OUTPUT_CLK_DIVIDER(1);
	        SET_CMOS_RISING_EDGE(0);
	        SET_CMOS_FALLING_EDGE(1);
	        ENABLE_CAMERA_PIXEL_CLKIN_ENABLE;
	        SET_TG_PIXEL_CLK_DIVIDER(1);
	        SET_CMOS_DATA_LATCH(1);
	}

	image_window->grab_start_x = iStartX;
	image_window->grab_start_y = iStartY;
	image_window->exposure_window_width =  SP0838_IMAGE_SENSOR_VGA_WIDTH - iStartX;
	image_window->exposure_window_height =  SP0838_IMAGE_SENSOR_VGA_HEIGHT - iStartY;

		kal_sleep_task(30);	
}	/* SP0838_capture() */

/*************************************************************************
* FUNCTION
*	write_SP0838_reg
*
* DESCRIPTION
*	This function set the register of SP0838.
*
* PARAMETERS
*	addr : the register index of SP0838
*  para : setting parameter of the specified register of SP0838
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_write_reg(kal_uint32 addr, kal_uint32 para)
{
	SP0838_write_cmos_sensor(addr,para);
}	/* write_SP0838_reg() */

/*************************************************************************
* FUNCTION
*	SP0838_read_cmos_sensor
*
* DESCRIPTION
*	This function read parameter of specified register from SP0838.
*
* PARAMETERS
*	addr : the register index of SP0838
*
* RETURNS
*	the data that read from SP0838
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_read_reg(kal_uint32 addr)
{
	return (SP0838_read_cmos_sensor(addr));
}	/* read_SP0838_reg() */

/*************************************************************************
* FUNCTION
*	set_SP0838_shutter
*
* DESCRIPTION
*	This function set e-shutter of SP0838 to change exposure time.
*
* PARAMETERS
*	shutter : exposured lines
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_set_shutter(kal_uint16 shutter)
{
  //  MY_CAM_TRACE_HEAD_1(SP0838_set_shutter, shutter);
	SP0838_exposure_lines=shutter;
	SP0838_write_shutter(shutter);
}	/* set_SP0838_shutter */

/*************************************************************************
* FUNCTION
*	set_SP0838_gain
*
* DESCRIPTION
*	This function is to set global gain to sensor.
*
* PARAMETERS
*	gain : sensor global gain(base: 0x40)
*
* RETURNS
*	the actually gain set to sensor.
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint16 SP0838_set_gain(kal_uint16 gain)
{
   return gain;
}

/*************************************************************************
* FUNCTION
*	SP0838_night_mode
*
* DESCRIPTION
*	This function night mode of SP0838.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_night_mode(kal_bool enable)
{
	if (/*SP0838_sensor_bVideoMode || */SP0838_sensor_bCaptureMode) //20110325 HL
	{
		return ;
	}

	if(!SP0838_s_bSensor_cap_state)
	{  
		if (!enable) //daylight
			{
			if(SP0838_sensor_bVideoMode)
				{
				dbg_print(" SP0838_banding=%x\r\n",SP0838_banding);
				if(SP0838_banding == 0)
				{
				//Video record daylight 24M 50hz fix 20FPS maxgain:0x78 
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x62);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5f);
				SP0838_write_cmos_sensor(0xf5,0x78);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xa9);
				SP0838_write_cmos_sensor(0x0f,0x60);
				SP0838_write_cmos_sensor(0x16,0x60);
				SP0838_write_cmos_sensor(0x17,0x91);
				SP0838_write_cmos_sensor(0x18,0x99);
				SP0838_write_cmos_sensor(0x1b,0x60);
				SP0838_write_cmos_sensor(0x1c,0x99);
				SP0838_write_cmos_sensor(0xb4,0x20);
				SP0838_write_cmos_sensor(0xb5,0x3a);
				SP0838_write_cmos_sensor(0xb6,0x5e);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x78);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x41);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x78);
				SP0838_write_cmos_sensor(0xcb,0x5 );
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x0f);		
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" video 50Hz normal\r\n");
				}
				else if(SP0838_banding == 1)
				{
				//Video record daylight 24M 60hz fix 20FPS maxgain:0x78               
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x51);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5c);
				SP0838_write_cmos_sensor(0xf5,0x75);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xa9);
				SP0838_write_cmos_sensor(0x0f,0x5d);
				SP0838_write_cmos_sensor(0x16,0x5d);
				SP0838_write_cmos_sensor(0x17,0x91);
				SP0838_write_cmos_sensor(0x18,0x99);
				SP0838_write_cmos_sensor(0x1b,0x5d);
				SP0838_write_cmos_sensor(0x1c,0x99);
				SP0838_write_cmos_sensor(0xb4,0x21);
				SP0838_write_cmos_sensor(0xb5,0x3d);
				SP0838_write_cmos_sensor(0xb6,0x4d);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x78);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x41);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x78);
				SP0838_write_cmos_sensor(0xcb,0x6 );
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x0f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" video 60Hz normal\r\n");
				}
			       }
			else
				{
				dbg_print(" SP0838_banding=%x\r\n",SP0838_banding);
			       if(SP0838_banding == 0)
				{
				//caprure preview daylight 24M 50hz 20-8FPS maxgain:0x70                 
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x62);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5f);
				SP0838_write_cmos_sensor(0xf5,0x78);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xb2);
				SP0838_write_cmos_sensor(0x0f,0x60);
				SP0838_write_cmos_sensor(0x16,0x60);
				SP0838_write_cmos_sensor(0x17,0xa2);
				SP0838_write_cmos_sensor(0x18,0xaa);
				SP0838_write_cmos_sensor(0x1b,0x60);
				SP0838_write_cmos_sensor(0x1c,0xaa);
				SP0838_write_cmos_sensor(0xb4,0x20);
				SP0838_write_cmos_sensor(0xb5,0x3a);
				SP0838_write_cmos_sensor(0xb6,0x5e);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x70);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x70);
				SP0838_write_cmos_sensor(0xcb,0xc );
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x0f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" priview 50Hz normal\r\n");
				}
				else if(SP0838_banding == 1)
				{
				//caprure preview daylight 24M 60hz 20-8FPS maxgain:0x70                   
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x51);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5c);
				SP0838_write_cmos_sensor(0xf5,0x75);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xb4);
				SP0838_write_cmos_sensor(0x0f,0x5d);
				SP0838_write_cmos_sensor(0x16,0x5d);
				SP0838_write_cmos_sensor(0x17,0xa4);
				SP0838_write_cmos_sensor(0x18,0xac);
				SP0838_write_cmos_sensor(0x1b,0x5d);
				SP0838_write_cmos_sensor(0x1c,0xac);
				SP0838_write_cmos_sensor(0xb4,0x21);
				SP0838_write_cmos_sensor(0xb5,0x3d);
				SP0838_write_cmos_sensor(0xb6,0x4d);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x41);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x70);
				SP0838_write_cmos_sensor(0xcb,0xf );
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x0f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" priview 60Hz normal\r\n");
				}
			       }
			}
		else //night mode
		       {
			if(SP0838_sensor_bVideoMode)
				{
				dbg_print(" SP0838_banding=%x\r\n",SP0838_banding);
				if(SP0838_banding == 0)
				{
				//Video record night 24M 50hz 20-10FPS maxgain:0x78                 
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x62);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5f);
				SP0838_write_cmos_sensor(0xf5,0x78);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xb6);
				SP0838_write_cmos_sensor(0x0f,0x60);
				SP0838_write_cmos_sensor(0x16,0x60);
				SP0838_write_cmos_sensor(0x17,0x9e);
				SP0838_write_cmos_sensor(0x18,0xa6);
				SP0838_write_cmos_sensor(0x1b,0x60);
				SP0838_write_cmos_sensor(0x1c,0xa6);
				SP0838_write_cmos_sensor(0xb4,0x20);
				SP0838_write_cmos_sensor(0xb5,0x3a);
				SP0838_write_cmos_sensor(0xb6,0x5e);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x78);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x41);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x78);
				SP0838_write_cmos_sensor(0xcb,0xa );
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x1f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" video 50Hz night\r\n");				
				}
				else if(SP0838_banding == 1)
				{
				//Video record night 24M 60hz 20-10FPS maxgain:0x78               
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x51);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5c);
				SP0838_write_cmos_sensor(0xf5,0x75);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xb7);
				SP0838_write_cmos_sensor(0x0f,0x5d);
				SP0838_write_cmos_sensor(0x16,0x5d);
				SP0838_write_cmos_sensor(0x17,0x9f);
				SP0838_write_cmos_sensor(0x18,0xa7);
				SP0838_write_cmos_sensor(0x1b,0x5d);
				SP0838_write_cmos_sensor(0x1c,0xa7);
				SP0838_write_cmos_sensor(0xb4,0x21);
				SP0838_write_cmos_sensor(0xb5,0x3d);
				SP0838_write_cmos_sensor(0xb6,0x4d);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x78);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x78);
				SP0838_write_cmos_sensor(0xcb,0xc );
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x1f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" video 60Hz night\r\n");	
				}
			       }
			else
				{
				dbg_print(" SP0838_banding=%x\r\n",SP0838_banding);
			       if(SP0838_banding == 0)
				{
				//caprure preview night 24M 50hz 20-6FPS maxgain:0x78                  
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x62);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5f);
				SP0838_write_cmos_sensor(0xf5,0x78);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xc0);
				SP0838_write_cmos_sensor(0x0f,0x60);
				SP0838_write_cmos_sensor(0x16,0x60);
				SP0838_write_cmos_sensor(0x17,0xa8);
				SP0838_write_cmos_sensor(0x18,0xb0);
				SP0838_write_cmos_sensor(0x1b,0x60);
				SP0838_write_cmos_sensor(0x1c,0xb0);
				SP0838_write_cmos_sensor(0xb4,0x20);
				SP0838_write_cmos_sensor(0xb5,0x3a);
				SP0838_write_cmos_sensor(0xb6,0x5e);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x41);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x78);
				SP0838_write_cmos_sensor(0xcb,0x10);
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x1f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" priview 50Hz night\r\n");	
				}
				else if(SP0838_banding == 1)
				{
				//caprure preview night 24M 60hz 20-6FPS maxgain:0x78                  
				SP0838_write_cmos_sensor(0xfd,0x00);
				SP0838_write_cmos_sensor(0x05,0x0 );
				SP0838_write_cmos_sensor(0x06,0x0 );
				SP0838_write_cmos_sensor(0x09,0x1 );
				SP0838_write_cmos_sensor(0x0a,0x76);
				SP0838_write_cmos_sensor(0xf0,0x51);
				SP0838_write_cmos_sensor(0xf1,0x0 );
				SP0838_write_cmos_sensor(0xf2,0x5c);
				SP0838_write_cmos_sensor(0xf5,0x75);
				SP0838_write_cmos_sensor(0xfd,0x01);
				SP0838_write_cmos_sensor(0x00,0xc1);
				SP0838_write_cmos_sensor(0x0f,0x5d);
				SP0838_write_cmos_sensor(0x16,0x5d);
				SP0838_write_cmos_sensor(0x17,0xa9);
				SP0838_write_cmos_sensor(0x18,0xb1);
				SP0838_write_cmos_sensor(0x1b,0x5d);
				SP0838_write_cmos_sensor(0x1c,0xb1);
				SP0838_write_cmos_sensor(0xb4,0x21);
				SP0838_write_cmos_sensor(0xb5,0x3d);
				SP0838_write_cmos_sensor(0xb6,0x4d);
				SP0838_write_cmos_sensor(0xb9,0x40);
				SP0838_write_cmos_sensor(0xba,0x4f);
				SP0838_write_cmos_sensor(0xbb,0x47);
				SP0838_write_cmos_sensor(0xbc,0x45);
				SP0838_write_cmos_sensor(0xbd,0x43);
				SP0838_write_cmos_sensor(0xbe,0x42);
				SP0838_write_cmos_sensor(0xbf,0x42);
				SP0838_write_cmos_sensor(0xc0,0x42);
				SP0838_write_cmos_sensor(0xc1,0x41);
				SP0838_write_cmos_sensor(0xc2,0x41);
				SP0838_write_cmos_sensor(0xc3,0x41);
				SP0838_write_cmos_sensor(0xc4,0x41);
				SP0838_write_cmos_sensor(0xc5,0x41);
				SP0838_write_cmos_sensor(0xc6,0x41);
				SP0838_write_cmos_sensor(0xca,0x78);
				SP0838_write_cmos_sensor(0xcb,0x14);
				SP0838_write_cmos_sensor(0x14,0x20);
				SP0838_write_cmos_sensor(0x15,0x1f);
				SP0838_write_cmos_sensor(0xfd,0x00);
				dbg_print(" priview 60Hz night\r\n");	
				}
			       }
		        }
	}
}	/* SP0838_night_mode */

#if (!defined(DRV_ISP_6219_SERIES))
/*************************************************************************
* FUNCTION
*	set_SP0838_flashlight
*
* DESCRIPTION
*	turn on/off SP0838 flashlight .
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
extern void flashlight_power_on(kal_bool on);
void SP0838_set_flashlight(kal_bool enable)
{
    flashlight_power_on(enable);
}
#endif

/*************************************************************************
* FUNCTION
*	set_SP0838_param_zoom
*
* DESCRIPTION
*	SP0838 zoom setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_zoom(kal_uint32 para)
{
	return KAL_FALSE;
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_contrast
*
* DESCRIPTION
*	SP0838 contrast setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_contrast(kal_uint32 para)
{
	// Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_brightness
*
* DESCRIPTION
*	SP0838 brightness setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_brightness(kal_uint32 para)
{
	// Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_hue
*
* DESCRIPTION
*	SP0838 hue setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_hue(kal_uint32 para)
{
	// Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_gamma
*
* DESCRIPTION
*	SP0838 gamma setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_gamma(kal_uint32 para)
{
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_wb
*
* DESCRIPTION
*	SP0838 wb setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_wb(kal_uint32 para)
{ 
	if (SP0838_sensor_bCaptureMode == KAL_TRUE)
	{
		return KAL_TRUE;
	}

	switch (para)
	{
		case CAM_WB_AUTO:   // enable AWB 
			//sp0838_reg_WB_auto         Զ     
			SP0838_write_cmos_sensor(0xfd,0x01);                                                          
			SP0838_write_cmos_sensor(0x28,0x75);		                                                       
			SP0838_write_cmos_sensor(0x29,0x4e);
			SP0838_write_cmos_sensor(0xfd,0x00);  // AUTO 3000K~7000K                                     
			SP0838_write_cmos_sensor(0x32,0x15);                                                                                                                                                                        
		break;

		case CAM_WB_CLOUD: 
			// sp0838_reg_WB_auto   
			SP0838_write_cmos_sensor(0xfd,0x00);   //7000K                                     
			SP0838_write_cmos_sensor(0x32,0x05);                                                          
			SP0838_write_cmos_sensor(0xfd,0x01);                                                          
			SP0838_write_cmos_sensor(0x28,0x71);		                                                       
			SP0838_write_cmos_sensor(0x29,0x41);		                                                       
            SP0838_write_cmos_sensor(0xfd,0x00);                                             
		break;

		case CAM_WB_DAYLIGHT: 
			// sp0838_reg_WB_auto   
			SP0838_write_cmos_sensor(0xfd,0x00);  //6500K                                     
			SP0838_write_cmos_sensor(0x32,0x05);                                                          
			SP0838_write_cmos_sensor(0xfd,0x01);                                                          
			SP0838_write_cmos_sensor(0x28,0x6b);		                                                       
			SP0838_write_cmos_sensor(0x29,0x48);		                                                       
            SP0838_write_cmos_sensor(0xfd,0x00);                                                         
		break;

		case CAM_WB_INCANDESCENCE: 
			// sp0838_reg_WB_auto ׳ 
			SP0838_write_cmos_sensor(0xfd,0x00);  //2800K~3000K                                     
			SP0838_write_cmos_sensor(0x32,0x05);                                                          
			SP0838_write_cmos_sensor(0xfd,0x01);                                                          
			SP0838_write_cmos_sensor(0x28,0x41);		                                                       
			SP0838_write_cmos_sensor(0x29,0x71);		                                                       
            SP0838_write_cmos_sensor(0xfd,0x00);                                                          
		break;

		case CAM_WB_FLUORESCENT: 
			//sp0838_reg_WB_auto  ӫ 
			SP0838_write_cmos_sensor(0xfd,0x00);  //4200K~5000K                                     
			SP0838_write_cmos_sensor(0x32,0x05);                                                          
			SP0838_write_cmos_sensor(0xfd,0x01);                                                          
			SP0838_write_cmos_sensor(0x28,0x5a);		                                                       
			SP0838_write_cmos_sensor(0x29,0x62);		                                                       
            SP0838_write_cmos_sensor(0xfd,0x00);                                                         
		break;

		case CAM_WB_TUNGSTEN: 
			// sp0838_reg_WB_auto ȹ
			SP0838_write_cmos_sensor(0xfd,0x00);  //4000K                                   
			SP0838_write_cmos_sensor(0x32,0x05);                                                          
			SP0838_write_cmos_sensor(0xfd,0x01);                                                          
			SP0838_write_cmos_sensor(0x28,0x57);		                                                       
			SP0838_write_cmos_sensor(0x29,0x66);		                                                       
            SP0838_write_cmos_sensor(0xfd,0x00);                                                         
		break;

		case CAM_WB_MANUAL:
		break;

		default:
		return KAL_FALSE;
	}

	return KAL_TRUE;
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_exposure
*
* DESCRIPTION
*	SP0838 exposure setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_exposure(kal_uint32 para)
{
	switch (para)
	{
		case CAM_EV_NEG_4_3:    // -4 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0xc0);
		break;

		case CAM_EV_NEG_3_3:    // -3 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0xd0);
		break;

		case CAM_EV_NEG_2_3:    // -2 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0xe0);
		break;

		case CAM_EV_NEG_1_3:    // -1 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0xf0);
		break;

		case CAM_EV_ZERO:   // +0 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0x00);
		break;

		case CAM_EV_POS_1_3:    // +1 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0x10);
		break;

		case CAM_EV_POS_2_3:    // +2 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0x20);
		break;

		case CAM_EV_POS_3_3:    // +3 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0x30);
		break;

		case CAM_EV_POS_4_3:    // +4 EV
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0xdc, 0x40);
		break;

		default:
		return KAL_FALSE;    
	}
	return KAL_TRUE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_effect
*
* DESCRIPTION
*	SP0838 effect setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_effect(kal_uint32 para)
{
    kal_uint32  ret = KAL_TRUE;

	switch (para)
	{
		case CAM_EFFECT_ENC_NORMAL:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x00);
			SP0838_write_cmos_sensor(0x63, 0x80);
			SP0838_write_cmos_sensor(0x64, 0x80);
		break;

		case CAM_EFFECT_ENC_GRAYSCALE:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x40);
			SP0838_write_cmos_sensor(0x63, 0x80);
			SP0838_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_SEPIA:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x20);
			SP0838_write_cmos_sensor(0x63, 0xc0);
			SP0838_write_cmos_sensor(0x64, 0x20);

		break;

		case CAM_EFFECT_ENC_COLORINV:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x10);
			SP0838_write_cmos_sensor(0x63, 0x80);
			SP0838_write_cmos_sensor(0x64, 0x80);
		break;

		case CAM_EFFECT_ENC_SEPIAGREEN:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x20);
			SP0838_write_cmos_sensor(0x63, 0x20);
			SP0838_write_cmos_sensor(0x64, 0x20);
		break;

		case CAM_EFFECT_ENC_SEPIABLUE:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x20);
			SP0838_write_cmos_sensor(0x63, 0x20);
			SP0838_write_cmos_sensor(0x64, 0xf0);

		break;

		case CAM_EFFECT_ENC_GRAYINV:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x10);
			SP0838_write_cmos_sensor(0x63, 0x80);
			SP0838_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_EMBOSSMENT:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x02);
			SP0838_write_cmos_sensor(0x63, 0x80);
			SP0838_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_SKETCH:
			SP0838_write_cmos_sensor(0xfd, 0x00);
			SP0838_write_cmos_sensor(0x62, 0x01);
			SP0838_write_cmos_sensor(0x63, 0x80);
			SP0838_write_cmos_sensor(0x64, 0x80);

		break;

		case CAM_EFFECT_ENC_WHITEBOARD:
		case CAM_EFFECT_ENC_COPPERCARVING:        
		case CAM_EFFECT_ENC_BLUECARVING:
		case CAM_EFFECT_ENC_CONTRAST:
		case CAM_EFFECT_ENC_JEAN:       
		case CAM_EFFECT_ENC_OIL:
		default:
		return 
			ret = KAL_FALSE;
	}

	return ret;
}

void SP0838_set_banding_for_50Hz()
{
}


void SP0838_set_banding_for_60Hz()
{ 
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_banding
*
* DESCRIPTION
*	SP0838 banding setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_banding(kal_uint32 para)
{
#if 0
	SP0838_s_bBanding_value = para;
	switch (para)
	{
		case CAM_BANDING_50HZ:
			 SP0838_set_banding_for_50Hz();
			 break;
		case CAM_BANDING_60HZ:
			 SP0838_set_banding_for_60Hz();
			 break;
		default:
			return KAL_FALSE;		
	}
#else
{
	if (SP0838_sensor_bCaptureMode == KAL_TRUE)
	{
		return KAL_TRUE;
	}

	switch (para)
	{
		case CAM_BANDING_50HZ:
              SP0838_banding = 0;
		dbg_print(" Banding 50Hz\r\n");	
		break;

		case CAM_BANDING_60HZ:
              SP0838_banding = 1;	
		dbg_print(" Banding 60Hz\r\n");	
		break;

		default:
		return KAL_FALSE;
	}

	return KAL_TRUE;
}

#endif
	//return KAL_TRUE;
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_saturation
*
* DESCRIPTION
*	SP0838 SATURATION setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_saturation(kal_uint32 para)
{
    // Not Support
	return KAL_FALSE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_nightmode
*
* DESCRIPTION
*	SP0838 night mode setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_nightmode(kal_uint32 para)
{
	SP0838_night_mode((kal_bool)para);
	return KAL_TRUE;	
}

/*************************************************************************
* FUNCTION
*	set_SP0838_param_ev
*
* DESCRIPTION
*	SP0838 ev setting.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_set_param_ev(kal_uint32 para)
{
	return SP0838_set_param_exposure(para);
}

/*************************************************************************
* FUNCTION
*	SP0838_yuv_sensor_setting
*
* DESCRIPTION
*	This function send command and parameter to yuv sensor module SP0838
*  to configure it
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
kal_uint32 SP0838_yuv_sensor_setting(kal_uint32 cmd, kal_uint32 para)
{
	kal_uint32 iRet = KAL_FALSE;

	if (SP0838_sensor_bCaptureMode == KAL_TRUE)
	{
		return KAL_TRUE;
	}
	
	switch (cmd)
	{

		case CAM_PARAM_ZOOM_FACTOR:
			iRet = SP0838_set_param_zoom(para);
		break;

		case CAM_PARAM_CONTRAST:
			iRet = SP0838_set_param_contrast(para);
		break;

		case CAM_PARAM_BRIGHTNESS:
			iRet =  SP0838_set_param_brightness(para);
		break;

		case CAM_PARAM_HUE:
			iRet = SP0838_set_param_hue(para);
		break;

		case CAM_PARAM_GAMMA:
			iRet = SP0838_set_param_gamma(para);
		break;

		case CAM_PARAM_WB:
			iRet =SP0838_set_param_wb(para);
		break;

		case CAM_PARAM_EXPOSURE:
			iRet = SP0838_set_param_exposure(para);//wait
		break;

		case CAM_PARAM_EFFECT:
			iRet = SP0838_set_param_effect(para);//wait
		break;

		case CAM_PARAM_BANDING:
			iRet = SP0838_set_param_banding(para);//wait
		break;

		case CAM_PARAM_SATURATION:
			iRet = SP0838_set_param_saturation(para);
		break;

		case CAM_PARAM_NIGHT_MODE:
			iRet = SP0838_set_param_nightmode(para);
		break;

		case CAM_PARAM_EV_VALUE:
			iRet = SP0838_set_param_ev(para);//wait
		break;

		default:
			iRet = KAL_FALSE;
	}

	return iRet;

}

/*************************************************************************
* FUNCTION
*	image_sensor_func_SP0838
*
* DESCRIPTION
*	SP0838 Image Sensor functions struct.
*
* PARAMETERS
*	none
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
image_sensor_func_struct image_sensor_func_SP0838=
{
	SP0838_init,
	SP0838_get_id,
	SP0838_get_size,
	SP0838_get_period,
	SP0838_preview,
	SP0838_capture,
	SP0838_write_reg,
	SP0838_read_reg,
	SP0838_set_shutter,
	SP0838_night_mode,
	SP0838_power_off,
	SP0838_set_gain
#if (!defined(DRV_ISP_6219_SERIES))
	,SP0838_set_flashlight
#endif
#if (defined(DRV_ISP_6238_SERIES))
	,NULL
	,NULL
#endif
//#if (defined(YUV_SENSOR_SUPPORT))
	,SP0838_yuv_sensor_setting
//#endif
};	/* image_sensor_func_SP0838 */

/*************************************************************************
* FUNCTION
*	cam_module_func_config
*
* DESCRIPTION
*	This function maps the external camera module function API structure.
*
* PARAMETERS
*
* RETURNS
*	None
*
* GLOBALS AFFECTED
*
*************************************************************************/
void SP0838_image_sensor_func_config(void)
{
	dbg_print("SP0838_image_sensor_func_config\r\n");
	image_sensor_func = &image_sensor_func_SP0838;
}	/* cam_module_func_config() */

// write camera_para to sensor register
void SP0838_camera_para_to_sensor(void)
{
	kal_uint32	i;
	
	for(i=0; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		SP0838_write_reg(camera_para.SENSOR.reg[i].addr, camera_para.SENSOR.reg[i].para);
	}
#if(! defined(DRV_ISP_6238_SERIES))	
	for(i=SP0838_FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		SP0838_write_reg(camera_para.SENSOR.reg[i].addr, camera_para.SENSOR.reg[i].para);
	}
	for(i=0; i<SP0838_CCT_END_ADDR; i++)
	{
		SP0838_write_reg(camera_para.SENSOR.cct[i].addr, camera_para.SENSOR.cct[i].para);
	}
#else
	for(i=FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		SP0838_write_reg(camera_para.SENSOR.reg[i].addr, camera_para.SENSOR.reg[i].para);
	}
	for(i=0; i<SP0838_CCT_END_ADDR; i++)
	{
		SP0838_write_reg(camera_para.SENSOR.cct[i].addr, camera_para.SENSOR.cct[i].para);
	}
#endif

}

// update camera_para from sensor register
void SP0838_sensor_to_camera_para(void)
{
#if 1
	kal_uint32	i;
	
	for(i=0; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		camera_para.SENSOR.reg[i].para = SP0838_read_reg(camera_para.SENSOR.reg[i].addr);
	}
#if(! defined(DRV_ISP_6238_SERIES))	
	for(i=SP0838_FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		camera_para.SENSOR.reg[i].para = SP0838_read_reg(camera_para.SENSOR.reg[i].addr);
	}
#else
	for(i=FACTORY_START_ADDR; 0xFFFFFFFF!=camera_para.SENSOR.reg[i].addr; i++)
	{
		camera_para.SENSOR.reg[i].para = SP0838_read_reg(camera_para.SENSOR.reg[i].addr);
	}
#endif
#endif
}

//------------------------Engineer mode---------------------------------

void  SP0838_get_sensor_group_count(kal_int32* sensor_count_ptr)
{
	return;
}

void SP0838_get_sensor_group_info(kal_uint16 group_idx, kal_int8* group_name_ptr, kal_int32* item_count_ptr)
{
}

void SP0838_get_sensor_item_info(kal_uint16 group_idx,kal_uint16 item_idx, ENG_sensor_info* info_ptr)
{
}

kal_bool SP0838_set_sensor_item_info(kal_uint16 group_idx, kal_uint16 item_idx, kal_int32 item_value)
{
    return KAL_FALSE;
}

void SP0838_get_sensor_prefix_name(kal_char* buf){
	strcpy(buf, "SP0838");
}

#if (defined(DRV_ISP_6238_SERIES))
void  SP0838_dispatch_camera_info(void) {
       kal_mem_cpy(&dsc_support_info, &SP0838_dsc_support_info, sizeof(camcorder_info_struct));	
}
#endif

kal_uint32 SP0838_get_valid_camera_type(void) {
	
	#if(defined(SP0838_YUV_MAIN))
		return  IMAGE_SENSOR_MAIN;			
	#elif(defined(SP0838_YUV_SUB))
		return  IMAGE_SENSOR_SUB;			
	#elif(defined(SP0838_YUV_BAK1))
		return  IMAGE_SENSOR_BAK1;			
	#elif(defined(SP0838_YUV_SUB_BAK1))
		return  IMAGE_SENSOR_SUB_BAK1;
	#endif									
	
}


