/*
* LFTG02F CMOS Camera Sensor Initialization
*/
#if CAMERATYPE == 7


// adjust_contrast()  and adjust_saturation() undefined  2010-03-31
#include <camera.h>
#include <jz4755.h>

#undef printf
//sxyzhang add for store the argments
#define Scence_Mode_Day      0
#define Scence_Mode_Night    1
#define White_Balance_Auto          0
#define White_Balance_Cloudy       1
#define White_Balance_Sunny        2
#define White_Balance_Incandesence  3
#define White_Balance_Fluorescent      4
#define White_Balance_Tungsten   5
#define Exposure_Mode_Indoor     0
#define Exposure_Mode_Outdoor   1
#define Special_Mode_Off            			0
#define Special_Mode_Black_White              1
#define Special_Mode_Antique           		2
#define Special_Mode_Greenish            		3
#define Special_Mode_Bluish            		4
#define Special_Mode_Negative            		5


//sxyzhang add over

extern unsigned char LFTG02F_INIT[];
extern unsigned char LFTG02F_PREVIEW[];
extern unsigned char LFTG02F_320_240[];
extern unsigned char LFTG02F_640_480[];
extern unsigned char LFT_DENIGHTMODE[];
extern unsigned char LFT_NIGHTMODE[];
extern unsigned char LFT_AUTOMODE[];
extern unsigned char LFT_SUNNYMODE[];
extern unsigned char LFT_INCANDESENCE[];
extern unsigned char LFT_CLOUDYMODE[];
extern unsigned char LFT_INDOORMODE[];
extern unsigned char LFT_OUTDOORMODE[];
extern unsigned char LFT_FLUORESCENT[];
extern unsigned char LFT_TUNGSTEN[];
extern unsigned char LFT_ANTIQUEMODE[];
extern unsigned char LFT_BLUISHMODE[];
extern unsigned char LFT_GREENISHMODE[];
extern unsigned char LFT_GRAYSCALEMODE[];
extern unsigned char LFT_BLACKWHITEMODE[];
extern unsigned char LFT_NORMALMODE[];
extern unsigned char LFT_NEGATIVEMODE[];
extern unsigned char LFT_ADJUST_BRIGHT_0[];
extern unsigned char LFT_ADJUST_BRIGHT_1[];
extern unsigned char LFT_ADJUST_BRIGHT_2[];
extern unsigned char LFT_ADJUST_BRIGHT_3[];
extern unsigned char LFT_ADJUST_BRIGHT_4[];
extern unsigned char LFT_ADJUST_BRIGHT_5[];
extern unsigned char LFT_ADJUST_BRIGHT_6[];
extern unsigned char LFT_ADJUST_SATURATION_0[];
extern unsigned char LFT_ADJUST_SATURATION_1[];
extern unsigned char LFT_ADJUST_SATURATION_2[];
extern unsigned char LFT_ADJUST_SATURATION_3[];
extern unsigned char LFT_ADJUST_SATURATION_4[];
extern unsigned char LFT_ADJUST_SATURATION_5[];
extern unsigned char LFT_ADJUST_SATURATION_6[];
extern unsigned char LFT_ADJUST_CONTRAST_0[];
extern unsigned char LFT_ADJUST_CONTRAST_1[];
extern unsigned char LFT_ADJUST_CONTRAST_2[];
extern unsigned char LFT_ADJUST_CONTRAST_3[];
extern unsigned char LFT_ADJUST_CONTRAST_4[];
extern unsigned char LFT_ADJUST_CONTRAST_5[];
extern unsigned char LFT_ADJUST_CONTRAST_6[];

static int Night_Switch ;
static int args[7]={0,3,0,0,0,3,3};
void Dcdv_Store_Arg(int *args );
//==================add by zyp Ƿ ͷ==============
void init_lft_gpio(void); 
static unsigned int camera_exist = 0;
unsigned int GetCameraStandby(void)
{
	return camera_exist;
}
void CheckCameraExist(void)
{
	//int bRet = 0;
	camera_exist = 0;

	__gpio_as_cim();
	init_lft_gpio();
	//bRet = sensor_write_reg(0x41,0x33);
	//if(bRet == 1)
		//camera_exist = 1;
	unsigned char id = 0;
	sensor_write_reg(0xfd,0x00);
	id = sensor_read_reg(0x02);
	if(id == 0x27)
		camera_exist = 1;
	printf("*************camera_exist = %d\n",camera_exist);
}

void CheckCameraStandby(void)
{
	T_camera_into_sleep();
	CheckCameraExist();
}
//================================end =======================
//ok
void lft_set_register(unsigned char * pRegBuf)
{
	unsigned char *pReg =  pRegBuf ;
	unsigned char reg,val ;
	while(*pReg != 0xff)
	{
		reg = *(pReg++);    
		val = *(pReg++);
		if(reg != 0xfe)
		{
			sensor_write_reg(reg,val);
		}
		else
		{
			udelay(val);	
		}
	}
}

void init_lft_vga(void)
{
	printf(" init_lft_vga    [%s][%d]\n",__FUNCTION__,__LINE__);
}	

void init_lft_qvga(void)
{
	printf(" init_lft_qvga    [%s][%d]\n",__FUNCTION__,__LINE__);
}

/* QVGA when SVGA mode */

void convert_to_qxga(void) 
{
	printf(" convert_to_qxga    [%s][%d]\n",__FUNCTION__,__LINE__);
}
void return_from_jpeg(void)
{
	printf(" return_from_jpeg    [%s][%d]\n",__FUNCTION__,__LINE__);
}


//ok
void Scence_Mode(int arg)
{
	char temp_reg;
	temp_reg = sensor_read_reg(0x41); 
	switch(arg)
	{
		case Scence_Mode_Day:  		
			Night_Switch = 0;
			lft_set_register(LFT_DENIGHTMODE);
			break;		
		case Scence_Mode_Night:  
			Night_Switch = 1;
			lft_set_register(LFT_NIGHTMODE);
			break;	
		default:
			lft_set_register(LFT_DENIGHTMODE);	
			break;	
	}
}


//ok
/////***********   ƽ   *************************////
void White_Balance(int arg)
{
	int temp_reg=sensor_read_reg(0x41);
	switch(arg)
	{
		case White_Balance_Auto:  	
			lft_set_register(LFT_AUTOMODE);       	
			break;		
		case White_Balance_Cloudy:  			
			lft_set_register(LFT_CLOUDYMODE);     	
			break;		
		case White_Balance_Sunny:  			
			lft_set_register(LFT_SUNNYMODE);     	
			break;
		case White_Balance_Incandesence:  	
			lft_set_register(LFT_INCANDESENCE);       	
			break;
		case White_Balance_Fluorescent:  			
			lft_set_register(LFT_FLUORESCENT);       	
			break;		
		case White_Balance_Tungsten:  
			lft_set_register(LFT_TUNGSTEN);       	
			break;	
		default:
			//sunny mode 
			lft_set_register(LFT_SUNNYMODE);   
			break;
	}

}

//ok
void Exposure_Mode(int arg)
{
	switch(arg)
	{
		case Exposure_Mode_Indoor: 		
			lft_set_register(LFT_INDOORMODE);
			break;	
		case Exposure_Mode_Outdoor: 
			lft_set_register(LFT_OUTDOORMODE);
			break;	
		default:
			lft_set_register(LFT_INDOORMODE);
			break;
	}
}

//ok
////*********  Ч************////
void Special_Mode(int arg)
{	
	int temp_reg;
	switch(arg)
	{
		case Special_Mode_Off:  
			lft_set_register(LFT_NORMALMODE);
			break;	
		case Special_Mode_Black_White:  
			lft_set_register(LFT_BLACKWHITEMODE);    	
			break;	
		case Special_Mode_Antique: 
			lft_set_register(LFT_ANTIQUEMODE);   	
			break;	
		case Special_Mode_Greenish: 
			lft_set_register(LFT_GREENISHMODE);    	
			break;	
		//case Special_Mode_Bluish: 
			//temp_reg=sensor_read_reg(0x41);
			//sensor_write_reg(0x41,temp_reg&~0x04); 
			//lft_set_register(LFT_BLUISHMODE); 	
			//break;	
		//case Special_Mode_Negative:  
		case Special_Mode_Bluish:	
			lft_set_register(LFT_NEGATIVEMODE);  	
			break;	
		default:
			lft_set_register(LFT_NORMALMODE);
		
	}
}

//ok
void adjust_bright ( unsigned  int level) 
{
	switch (level)
	{
		case 0:    
			lft_set_register(LFT_ADJUST_BRIGHT_0);
			break;		
		case 1:
			lft_set_register(LFT_ADJUST_BRIGHT_1);
			break;		
		case 2:
			lft_set_register(LFT_ADJUST_BRIGHT_2);
			break;				
		case 3:
			lft_set_register(LFT_ADJUST_BRIGHT_3);
			break;				
		case 4:
			lft_set_register(LFT_ADJUST_BRIGHT_4);
			break;				
		case 5:
			lft_set_register(LFT_ADJUST_BRIGHT_5);
			break;				
		case 6:
			lft_set_register(LFT_ADJUST_BRIGHT_6);
			break;				
		default:
			lft_set_register(LFT_ADJUST_BRIGHT_3);
			break;				
	}	
	return ;		
}

//empty now
void adjust_saturation ( unsigned  int level) 
{
switch (level)
	{
		case 0:    
			lft_set_register(LFT_ADJUST_SATURATION_0);
			break;		
		case 1:
			lft_set_register(LFT_ADJUST_SATURATION_1);
			break;		
		case 2:
			lft_set_register(LFT_ADJUST_SATURATION_2);
			break;				
		case 3:
			lft_set_register(LFT_ADJUST_SATURATION_3);
			break;				
		case 4:
			lft_set_register(LFT_ADJUST_SATURATION_4);
			break;				
		case 5:
			lft_set_register(LFT_ADJUST_SATURATION_5);
			break;				
		case 6:
			lft_set_register(LFT_ADJUST_SATURATION_6);
			break;				
		default:
			lft_set_register(LFT_ADJUST_SATURATION_3);	
			break;				
	}	
	return ;		
}

//empty now
void adjust_contrast( unsigned  int level) 
{
switch (level)
	{
		case 0:    
			lft_set_register(LFT_ADJUST_CONTRAST_0);
			break;		
		case 1:
			lft_set_register(LFT_ADJUST_CONTRAST_1);
			break;		
		case 2:
			lft_set_register(LFT_ADJUST_CONTRAST_2);
			break;				
		case 3:
			lft_set_register(LFT_ADJUST_CONTRAST_3);
			break;				
		case 4:
			lft_set_register(LFT_ADJUST_CONTRAST_4);
			break;				
		case 5:
			lft_set_register(LFT_ADJUST_CONTRAST_5);
			break;				
		case 6:
			lft_set_register(LFT_ADJUST_CONTRAST_6);
			break;				
		default:
			lft_set_register(LFT_ADJUST_CONTRAST_3);
			break;				
	}	
	return ;		
}

//ok
void init_lft_gpio(void) 
{
	gpio_set_dir(CAM_STANDBY_PIN, 1, 0);
	//modify by zyp  ͷҪreset ,outvol
	/*gpio_set_dir(CAM_RESET_PIN, 1, 1);
	mdelay(100);
	gpio_set_dir(CAM_RESET_PIN, 1, 0);
	mdelay(100);
	gpio_set_dir(CAM_RESET_PIN, 1, 1);*/
	
	mdelay(100);
}

void output_jpeg(void) 
{
	printf(" output_jpeg    [%s][%d]\n",__FUNCTION__,__LINE__);
}

void output_yuv(void) 
{
	printf(" output_yuv    [%s][%d]\n",__FUNCTION__,__LINE__);
}

void preview_init(void)
{

}
capture_init(void )
{
	
}

/*
* Sensor Init Routine
*/

//ok
void set_args(int *data)
{
	int i;
	for(i=0;i<7;i++)
	{
		args[i] = data[i];
	}
}

unsigned char Sensor_ID_Check()
{
	unsigned char id = 0;
	sensor_write_reg(0xfd,0x00);
	id = sensor_read_reg(0x02);
	return id;
}

//ok
int init_sensor(img_param_cim *img)
{
		//printf("	lftg02f ####init_sensor#########################\n"); 
#if(TYD_CHARGE_LIGHT == 1)
		SetChargeLightEnable(1);
#endif
		init_lft_gpio();
		sensor_set_addr(0x30);
		sensor_set_clk(50000);
		//printf("@@@SP:SP0838 sensor ID=0x%x\r\n",Sensor_ID_Check());
		
		lft_set_register(LFTG02F_INIT);
		Dcdv_Store_Arg(args);
		//lft_set_register(LFTG02F_PREVIEW);

		//printf("@@@SP:in-W=%d in-H=%d\r\n",img->in_width,img->in_height);
		//lft_set_register(LFTG02F_640_480);	

		if(img->in_width == 320 && img->in_height == 240)
		{
			lft_set_register(LFTG02F_320_240);
		}

		if(img->in_width == 640 && img->in_height == 480)	
		{
			lft_set_register(LFTG02F_640_480);	
		}
#if(TYD_CHARGE_LIGHT == 1)
		SetChargeLightEnable(0);
#endif
}

//ok
void camera_size(img_param_cim *img)
{
	//printf("camera_size    img->in_width:[%d],     img->in_height :[%d] \n",img->in_width,img->in_height );
	if(img->in_width != 320 && img->in_height != 240)
	{		
			lft_set_register(LFTG02F_640_480);	
	}	
	else
	{
			lft_set_register(LFTG02F_320_240);
	}	
}

/*
****************Dcdv_Store_Arg()   **************************
argment:
args[0]:white balance
args[1]:bright
args[2]:exposure mode 
args[3]:special mode
args[4]:scence mode
args[5]:contrast 
args[6]:saturation
*****************end****************************************
*/
void Dcdv_Store_Arg(int *args )
{
	Special_Mode(args[3]);                 //   modify by zyp must be first
	White_Balance(args[0]);
	adjust_bright(args[1]);
	Exposure_Mode(args[2]);
	Scence_Mode(args[4]);
	adjust_contrast(args[5]);
	adjust_saturation(args[6]);	
}
#endif

